"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const filesize_1 = require("filesize");
const Styles = __importStar(require("./style"));
const React = __importStar(require("react"));
const react_1 = require("react");
const SvgFromUrl_1 = __importDefault(require("../../SvgFromUrl"));
function GenericAttachment(props) {
    const icon = (0, react_1.useMemo)(() => {
        var _a;
        switch ((_a = props.icon) !== null && _a !== void 0 ? _a : "unknown") {
            case "archive":
                return "FileArchive";
            case "audio":
                return "FileAudio";
            case "sketch":
                return "FileSketch";
            case "acrobat":
                return "FileAcrobat";
            case "ae":
                return "FileAe";
            case "ai":
                return "FileAi";
            case "code":
                return "FileCode";
            case "document":
                return "FileDocument";
            case "spreadsheet":
                return "FileSpreadsheet";
            case "webcode":
                return "FileWebCode";
            default:
                return "FileUnknown";
        }
    }, [props.icon]);
    return (React.createElement(Styles.AttachmentContainer, { withoutChildren: props.children === undefined },
        React.createElement(SvgFromUrl_1.default, { svg: icon, width: 30, height: 40 }),
        React.createElement(Styles.AttachmentMetadata, null,
            React.createElement(Styles.AttachmentFileName, { rel: "noreferrer noopener", target: "_blank", href: props.attachment.url }, props.attachment.filename),
            React.createElement(Styles.AttachmentFileSize, null, (0, filesize_1.filesize)(props.attachment.size, { base: 2 }))),
        React.createElement(Styles.DownloadIcon, { rel: "noreferrer noopener", target: "_blank", href: props.attachment.url },
            React.createElement(SvgFromUrl_1.default, { svg: "IconDownload", width: 24, height: 24 })),
        props.children && (React.createElement(Styles.ExtraUserInterface, null, props.children))));
}
exports.default = GenericAttachment;
//# sourceMappingURL=GenericAttachment.js.map