"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const VideoAttachment_1 = __importDefault(require("./VideoAttachment"));
const react_1 = __importStar(require("react"));
const ImageAttachment_1 = __importDefault(require("./ImageAttachment"));
const GenericAttachment_1 = __importDefault(require("./GenericAttachment"));
const Styles = __importStar(require("./style"));
function AttachmentBase(props) {
    if (props.attachment.width && props.attachment.height) {
        if (/\.(?:mp4|webm|mov)$/.test(props.attachment.filename))
            return react_1.default.createElement(VideoAttachment_1.default, { attachmentOrEmbed: props.attachment });
        return react_1.default.createElement(ImageAttachment_1.default, { attachment: props.attachment });
    }
    // TODO: try to avoid the same component being reused with just a different icon
    if (/\.(?:mp3|ogg|wav|flac)$/.test(props.attachment.filename))
        return (react_1.default.createElement(GenericAttachment_1.default, { attachment: props.attachment, icon: "audio" },
            react_1.default.createElement(Styles.AttachmentAudioControls, { controls: true, src: props.attachment.url })));
    if (/\.sketch$/.test(props.attachment.filename))
        return react_1.default.createElement(GenericAttachment_1.default, { attachment: props.attachment, icon: "sketch" });
    if (/\.pdf$/.test(props.attachment.filename))
        return react_1.default.createElement(GenericAttachment_1.default, { attachment: props.attachment, icon: "acrobat" });
    if (/\.ae$/.test(props.attachment.filename))
        return react_1.default.createElement(GenericAttachment_1.default, { attachment: props.attachment, icon: "ae" });
    if (/\.ai$/.test(props.attachment.filename))
        return react_1.default.createElement(GenericAttachment_1.default, { attachment: props.attachment, icon: "ai" });
    if (/\.(?:rar|zip|7z|tar|tar\.gz)$/.test(props.attachment.filename))
        return react_1.default.createElement(GenericAttachment_1.default, { attachment: props.attachment, icon: "archive" });
    if (/\.(?:c\+\+|cpp|cc|c|h|hpp|mm|m|json|js|rb|rake|py|asm|fs|pyc|dtd|cgi|bat|rss|java|graphml|idb|lua|o|gml|prl|sls|conf|cmake|make|sln|vbe|cxx|wbf|vbs|r|wml|php|bash|applescript|fcgi|yaml|ex|exs|sh|ml|actionscript)$/.test(props.attachment.filename))
        return react_1.default.createElement(GenericAttachment_1.default, { attachment: props.attachment, icon: "code" });
    if (/\.(?:txt|rtf|doc|docx|md|pages|ppt|pptx|pptm|key|log)$/.test(props.attachment.filename))
        return react_1.default.createElement(GenericAttachment_1.default, { attachment: props.attachment, icon: "document" });
    if (/\.(?:xls|xlsx|numbers|csv)$/.test(props.attachment.filename))
        return (react_1.default.createElement(GenericAttachment_1.default, { attachment: props.attachment, icon: "spreadsheet" }));
    if (/\.(?:html|xhtml|htm|js|xml|xls|xsd|css|styl)$/.test(props.attachment.filename))
        return react_1.default.createElement(GenericAttachment_1.default, { attachment: props.attachment, icon: "webcode" });
    return react_1.default.createElement(GenericAttachment_1.default, { attachment: props.attachment, icon: "unknown" });
}
function AttachmentContainer(props) {
    const [showSpoiler, setShowSpoiler] = (0, react_1.useState)(false);
    if (props.attachment.filename.startsWith("SPOILER_"))
        return (react_1.default.createElement(Styles.Spoiler, { "data-show": showSpoiler, onClick: () => setShowSpoiler(true) },
            react_1.default.createElement(AttachmentBase, { attachment: props.attachment })));
    return react_1.default.createElement(AttachmentBase, { attachment: props.attachment });
}
function Attachment(props) {
    return react_1.default.createElement(AttachmentContainer, { attachment: props.attachment });
}
exports.default = (0, react_1.memo)(Attachment);
//# sourceMappingURL=index.js.map