"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AttachmentAudioControls = exports.ExtraUserInterface = exports.DownloadIcon = exports.AttachmentFileSize = exports.AttachmentFileName = exports.AttachmentMetadata = exports.AttachmentContainer = exports.Spoiler = exports.ProgressBar = exports.ProgressBarFill = exports.VideoControlButton = exports.VideoControlsTime = exports.VideoControls = exports.VideoMetadataFilesize = exports.VideoMetadataTitle = exports.VideoMetadata = exports.PlayOrPauseButtonAnimation = exports.PlayOrPauseAnimationDuration = exports.VideoAttachmentOverlayControl = exports.VideoAttachmentOverlay = exports.VideoAttachment = exports.VideoAttachmentContainer = exports.LazyImagePlaceholder = exports.ImageAttachment = void 0;
const stitches_config_1 = require("../../Stitches/stitches.config");
const SvgFromUrl_1 = __importDefault(require("../../SvgFromUrl"));
const react_lazy_load_image_component_1 = require("react-lazy-load-image-component");
exports.ImageAttachment = stitches_config_1.styled.withConfig({
    displayName: "image-attachment",
    componentId: stitches_config_1.commonComponentId,
})(react_lazy_load_image_component_1.LazyLoadImage, {
    cursor: "pointer",
});
exports.LazyImagePlaceholder = stitches_config_1.styled.withConfig({
    displayName: "lazy-image-placeholder",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    backgroundColor: stitches_config_1.theme.colors.lazyImageBackground,
    color: stitches_config_1.theme.colors.primaryOpacity100,
    display: "flex",
    alignItems: "center",
    justifyContent: "center",
});
exports.VideoAttachmentContainer = stitches_config_1.styled.withConfig({
    displayName: "video-attachment-container",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    borderRadius: 3,
    overflow: "hidden",
    maxWidth: "min(400px, 100%)",
    backgroundColor: stitches_config_1.theme.colors.backgroundTertiary,
    cursor: "pointer",
    position: "relative",
    display: "flex",
});
exports.VideoAttachment = stitches_config_1.styled.withConfig({
    displayName: "video-attachment",
    componentId: stitches_config_1.commonComponentId,
})("video", {
    outline: "none",
    cursor: "pointer",
    "&[width]": {
        maxWidth: "min(400px, 100%)",
    },
    "&:not([width])": {
        position: "fixed",
        width: "100%",
        height: "100%",
    },
});
exports.VideoAttachmentOverlay = stitches_config_1.styled.withConfig({
    displayName: "video-attachment-overlay",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    position: "absolute",
    top: 0,
    width: "100%",
    height: "100%",
    borderRadius: 3,
    overflow: "hidden",
    display: "flex",
    flexDirection: "column",
    color: stitches_config_1.theme.colors.primaryOpacity100,
    $$overlayMetaDataTranslateY: "-100%",
    $$overlayControlsTranslateY: "100%",
    "&[data-paused='true']": {
        $$overlayMetaDataTranslateY: "0 !important",
    },
    "&:hover": {
        $$overlayMetaDataTranslateY: 0,
        $$overlayControlsTranslateY: 0,
    },
    "&[data-paused='true'][data-played-once='true']": {
        $$overlayControlsTranslateY: 0,
    },
    "&[data-played-once='false']": {
        $$overlayControlsTranslateY: "100%",
    },
});
exports.VideoAttachmentOverlayControl = stitches_config_1.styled.withConfig({
    displayName: "video-attachment-overlay-control",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    flex: "1 0",
});
const stateChange = (0, stitches_config_1.keyframes)({
    from: {
        backgroundColor: stitches_config_1.theme.colors.transparentBlack,
        scale: 1.5,
    },
    to: {
        scale: 2.5,
    },
});
exports.PlayOrPauseAnimationDuration = 400;
exports.PlayOrPauseButtonAnimation = stitches_config_1.styled.withConfig({
    displayName: "play-or-pause-button-animation",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    position: "absolute",
    top: "50%",
    left: "50%",
    translate: "-50% -50%",
    width: 40,
    height: 40,
    borderRadius: "100%",
    padding: stitches_config_1.theme.space.xl,
    pointerEvents: "none",
    boxSizing: "border-box",
    display: "flex",
    alignItems: "center",
    justifyContent: "center",
    "&[data-has-played-before='true']": {
        animation: `${stateChange} ${exports.PlayOrPauseAnimationDuration}ms ease-in-out`,
    },
    "&[data-has-played-before='false']": {
        backgroundColor: stitches_config_1.theme.colors.transparentBlack,
    },
});
exports.VideoMetadata = stitches_config_1.styled.withConfig({
    displayName: "video-metadata",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    padding: stitches_config_1.theme.space.xl,
    transition: "translate 0.1s ease-in-out",
    translate: "0 $$overlayMetaDataTranslateY",
    backgroundImage: `linear-gradient(0deg, transparent, ${stitches_config_1.theme.colors.transparentBlack})`,
});
exports.VideoMetadataTitle = stitches_config_1.styled.withConfig({
    displayName: "video-metadata-title",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    fontSize: stitches_config_1.theme.fontSizes.l,
    fontWeight: 500,
    textOverflow: "ellipsis",
    overflow: "hidden",
    whiteSpace: "nowrap",
});
exports.VideoMetadataFilesize = stitches_config_1.styled.withConfig({
    displayName: "video-metadata-filesize",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    fontWeight: 500,
    fontSize: stitches_config_1.theme.fontSizes.s,
    opacity: 0.7,
});
exports.VideoControls = stitches_config_1.styled.withConfig({
    displayName: "video-controls",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    position: "absolute",
    display: "flex",
    bottom: 0,
    width: "100%",
    padding: stitches_config_1.theme.space.large,
    paddingTop: stitches_config_1.theme.space.medium,
    paddingBottom: stitches_config_1.theme.space.medium,
    gap: stitches_config_1.theme.space.large,
    alignItems: "center",
    boxSizing: "border-box",
    backgroundColor: stitches_config_1.theme.colors.transparentBlack,
    transition: "translate 0.1s ease-in-out",
    translate: "0 $$overlayControlsTranslateY",
});
exports.VideoControlsTime = stitches_config_1.styled.withConfig({
    displayName: "video-controls-time",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    fontSize: stitches_config_1.theme.fontSizes.s,
    fontFamily: "Consolas, monospace",
    userSelect: "none",
});
exports.VideoControlButton = stitches_config_1.styled.withConfig({
    displayName: "video-control-button",
    componentId: stitches_config_1.commonComponentId,
})(SvgFromUrl_1.default, {
    border: "none",
    background: "none",
    backgroundSize: "$$size $$size",
    transition: "opacity 0.1s ease-in-out",
    opacity: 0.6,
    cursor: "pointer",
    "&:hover": {
        opacity: 1,
    },
});
exports.ProgressBarFill = stitches_config_1.styled.withConfig({
    displayName: "progress-bar-fill",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    height: "100%",
    position: "relative",
    borderRadius: "$$borderRadius",
    pointerEvents: "none",
    backgroundColor: stitches_config_1.theme.colors.accent,
});
exports.ProgressBar = stitches_config_1.styled.withConfig({
    displayName: "progress-bar",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    $$borderRadius: "80px",
    height: 6,
    borderRadius: "$$borderRadius",
    flex: "1 0",
    cursor: "pointer",
    backgroundColor: stitches_config_1.theme.colors.primaryOpacity30,
    [`&:hover ${exports.ProgressBarFill}:after`]: {
        content: "",
        position: "absolute",
        right: 0,
        top: "50%",
        width: 12,
        height: 12,
        borderRadius: "100%",
        translate: "50% -50%",
        backgroundColor: stitches_config_1.theme.colors.accent,
    },
});
exports.Spoiler = stitches_config_1.styled.withConfig({
    displayName: "spoiler",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    overflow: "hidden",
    position: "relative",
    width: "fit-content",
    height: "fit-content",
    borderRadius: 3,
    "& > *": {
        transition: "filter 0.2s ease-in-out",
        filter: "blur(44px)",
    },
    "&[data-show='true'] > *": {
        filter: "blur(0)",
    },
    "&[data-show='false']": {
        cursor: "pointer",
        "& > *": {
            pointerEvents: "none",
        },
        "&:after": {
            content: "SPOILER",
            backgroundColor: stitches_config_1.theme.colors.transparentBlack,
            color: stitches_config_1.theme.colors.primaryOpacity100,
            borderRadius: 100,
            padding: `${stitches_config_1.theme.space.large} ${stitches_config_1.theme.space.xl}`,
            position: "absolute",
            left: "50%",
            top: "50%",
            translate: "-50% -50%",
            fontWeight: 600,
            fontSize: stitches_config_1.theme.fontSizes.l,
            letterSpacing: 0.5,
        },
        "&:hover:after": {
            backgroundColor: stitches_config_1.theme.colors.blackSpoilerHover,
        },
    },
});
exports.AttachmentContainer = stitches_config_1.styled.withConfig({
    displayName: "attachment-container",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    display: "flex",
    backgroundColor: stitches_config_1.theme.colors.backgroundSecondary,
    padding: 10,
    border: `1px solid ${stitches_config_1.theme.colors.attachmentBorder}`,
    borderRadius: 3,
    width: "fit-content",
    flexWrap: "wrap",
    variants: {
        withoutChildren: {
            true: {
                alignItems: "center",
            },
        },
    },
});
exports.AttachmentMetadata = stitches_config_1.styled.withConfig({
    displayName: "attachment-metadata",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    margin: `0 ${stitches_config_1.theme.space.large}`,
    display: "flex",
    flexDirection: "column",
});
exports.AttachmentFileName = stitches_config_1.styled.withConfig({
    displayName: "attachment-file-name",
    componentId: stitches_config_1.commonComponentId,
})("a", {
    color: stitches_config_1.theme.colors.link,
    maxWidth: "40vw",
    overflow: "hidden",
    textOverflow: "ellipsis",
    whiteSpace: "nowrap",
    textDecoration: "none",
    "&:hover": {
        textDecoration: "underline",
    },
});
exports.AttachmentFileSize = stitches_config_1.styled.withConfig({
    displayName: "attachment-file-size",
    componentId: stitches_config_1.commonComponentId,
})("span", {
    fontSize: stitches_config_1.theme.fontSizes.s,
    color: stitches_config_1.theme.colors.primaryDark,
});
exports.DownloadIcon = stitches_config_1.styled.withConfig({
    displayName: "attachment-download-icon",
    componentId: stitches_config_1.commonComponentId,
})("a", {
    opacity: 0.8,
    marginLeft: "auto",
    color: stitches_config_1.theme.colors.primaryOpacity100,
    display: "flex",
    "&:hover": {
        opacity: 1,
    },
});
exports.ExtraUserInterface = stitches_config_1.styled.withConfig({
    displayName: "attachment-extra-ui",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    flexBasis: "100%",
    marginTop: stitches_config_1.theme.space.large,
    display: "flex",
});
exports.AttachmentAudioControls = stitches_config_1.styled.withConfig({
    displayName: "attachment-audio-controls",
    componentId: stitches_config_1.commonComponentId,
})("audio", {
    flex: 1,
    height: 32,
    outline: "none",
    borderRadius: 3,
    maxWidth: "70vw",
});
//# sourceMappingURL=style.js.map