"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const MaxAttachmentWidth = 400;
const MaxAttachmentHeight = 300;
function useSize(width, height, disabled) {
    if (disabled) {
        return {
            width: undefined,
            height: undefined,
        };
    }
    const resultingWidth = Math.min(Math.floor((Math.min(height, MaxAttachmentHeight) / height) * width), MaxAttachmentWidth);
    const resultingHeight = Math.min(height, MaxAttachmentHeight, (resultingWidth / width) * height);
    return {
        width: resultingWidth,
        height: resultingHeight,
    };
}
exports.default = useSize;
//# sourceMappingURL=useSize.js.map