"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Styles = __importStar(require("./style"));
const react_1 = __importStar(require("react"));
const useSize_1 = __importDefault(require("../Attachment/useSize"));
const svgs_1 = require("../../core/svgs");
const VideoAttachment_1 = __importDefault(require("../Attachment/VideoAttachment"));
function ThumbnailWrapper({ thumbnail, width, height, children, }) {
    const [hideThumbnail, setHideThumbnail] = (0, react_1.useState)(false);
    const [error, setError] = (0, react_1.useState)(false);
    const { width: adjustedWidth, height: adjustedHeight } = (0, useSize_1.default)(width, height);
    if (!thumbnail || hideThumbnail)
        return react_1.default.createElement(react_1.default.Fragment, null, children);
    const discordImageFailure = (0, svgs_1.getSvgUrl)("MiscDiscordImageFailure");
    return (react_1.default.createElement(Styles.VideoThumbnail, { onClick: () => setHideThumbnail(true), onError: () => setError(true), style: {
            width: adjustedWidth,
            height: adjustedHeight,
            backgroundImage: `url(${error ? discordImageFailure : thumbnail})`,
        } },
        react_1.default.createElement(Styles.VideoThumbnailPlayButtonContainer, null,
            react_1.default.createElement(Styles.VideoThumbnailPlayButton, { width: 12, height: 12, svg: "IconPlay" }))));
}
function EmbedVideo(props) {
    if (props.proxyUrl !== undefined)
        return (react_1.default.createElement(ThumbnailWrapper, { thumbnail: props.thumbnail, width: props.width, height: props.height },
            react_1.default.createElement(VideoAttachment_1.default, { attachmentOrEmbed: {
                    width: props.width,
                    height: props.height,
                    url: props.proxyUrl,
                } })));
    const url = new URL(props.url);
    url.searchParams.set("autoplay", "1");
    url.searchParams.set("auto_play", "1");
    return (react_1.default.createElement(ThumbnailWrapper, { thumbnail: props.thumbnail, width: props.width, height: props.height },
        react_1.default.createElement(Styles.VideoIframe, { width: 400, height: 225, src: url.toString(), allowFullScreen: true })));
}
exports.default = EmbedVideo;
//# sourceMappingURL=EmbedVideo.js.map