"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const GifVEmbed_1 = __importDefault(require("./GifVEmbed"));
const ImageEmbed_1 = __importDefault(require("./ImageEmbed"));
const VideoAttachment_1 = __importDefault(require("../Attachment/VideoAttachment"));
const Styles = __importStar(require("./style"));
const numberToRgb_1 = __importDefault(require("../../utils/numberToRgb"));
const moment_1 = __importDefault(require("moment"));
const render_1 = require("../../markdown/render");
const useSize_1 = __importDefault(require("./useSize"));
const EmbedVideo_1 = __importDefault(require("./EmbedVideo"));
const react_1 = __importStar(require("react"));
const v10_1 = require("discord-api-types/v10");
function Embed({ embed, images }) {
    var _a, _b;
    if (embed.type === v10_1.EmbedType.GIFV)
        return react_1.default.createElement(GifVEmbed_1.default, { embed: embed });
    if (embed.type === v10_1.EmbedType.Image)
        return react_1.default.createElement(ImageEmbed_1.default, { embed: embed });
    if (embed.type === v10_1.EmbedType.Video && !embed.thumbnail)
        return react_1.default.createElement(VideoAttachment_1.default, { attachmentOrEmbed: embed });
    const embedColor = embed.color !== 0 && embed.color !== undefined
        ? (0, numberToRgb_1.default)(embed.color)
        : undefined;
    const { width: widthImage, height: heightImage } = (0, useSize_1.default)(embed.type, embed.image, "EmbedImage", (images === null || images === void 0 ? void 0 : images.length) > 0);
    const { width: widthThumbnail, height: heightThumbnail, isLarge: isThumbnailLarge, } = (0, useSize_1.default)(embed.type, embed.thumbnail, "EmbedThumbnail", undefined);
    const isEmbedThin = (0, react_1.useMemo)(() => widthImage !== null ||
        (embed.type === v10_1.EmbedType.Video && embed.thumbnail !== null), [widthImage, embed.type, embed.thumbnail]);
    return (react_1.default.createElement(Styles.Embed, { style: { borderLeftColor: embedColor }, thin: isEmbedThin },
        react_1.default.createElement(Styles.ContentAndThumbnail, { hasLargeThumbnail: isThumbnailLarge },
            react_1.default.createElement(Styles.Content, null,
                embed.provider && (react_1.default.createElement(Styles.Provider, null, embed.provider.name)),
                embed.author && (react_1.default.createElement(Styles.Author, null,
                    embed.author.proxy_icon_url && (react_1.default.createElement(Styles.AuthorIcon, { src: embed.author.proxy_icon_url })),
                    react_1.default.createElement(Styles.AuthorName, null, embed.author.url ? (react_1.default.createElement("a", { href: embed.author.url, target: "_blank", rel: "noreferrer noopener" }, embed.author.name)) : (embed.author.name)))),
                embed.title &&
                    (embed.url !== undefined ? (react_1.default.createElement(Styles.Title, { as: "a", link: true, href: embed.url, target: "_blank" }, (0, render_1.parseEmbedTitle)(embed.title))) : (react_1.default.createElement(Styles.Title, null, (0, render_1.parseEmbedTitle)(embed.title)))),
                embed.type === v10_1.EmbedType.Video ? (react_1.default.createElement(EmbedVideo_1.default, { url: embed.video.url, proxyUrl: embed.video.proxy_url, width: embed.video.width, height: embed.video.height, thumbnail: embed.thumbnail.proxy_url })) : (embed.description && (react_1.default.createElement(Styles.Description, null,
                    react_1.default.createElement(render_1.LinkMarkdown, null, embed.description)))),
                embed.fields && embed.fields.length > 0 && (react_1.default.createElement(Styles.Fields, null, embed.fields.map((field) => (react_1.default.createElement(Styles.Field, { key: field.name + field.value, inline: field.inline },
                    react_1.default.createElement(Styles.FieldName, null, (0, render_1.parseEmbedTitle)(field.name)),
                    react_1.default.createElement(Styles.FieldValue, null,
                        react_1.default.createElement(render_1.LinkMarkdown, null, field.value)))))))),
            embed.thumbnail && embed.type !== v10_1.EmbedType.Video && (react_1.default.createElement(Styles.Image, { src: embed.thumbnail.proxy_url, 
                // originalUrl={embed.thumbnail.url}
                width: widthThumbnail, height: heightThumbnail }))),
        (images === undefined || (images === null || images === void 0 ? void 0 : images.length) === 0) && embed.image && (react_1.default.createElement(Styles.Image, { src: embed.image.proxy_url, 
            // originalUrl={embed.image.url}
            width: widthImage, height: heightImage })),
        (images === null || images === void 0 ? void 0 : images.length) > 0 && (react_1.default.createElement(Styles.Images, { nImages: images.length }, images.map((image) => (react_1.default.createElement(Styles.ImageGridImageContainer, { key: image.url },
            react_1.default.createElement(Styles.Image, { src: image.proxy_url, 
                // originalUrl={image.url}
                withMargin: true })))))),
        (embed.footer || embed.timestamp) && (react_1.default.createElement(Styles.Footer, null,
            ((_a = embed.footer) === null || _a === void 0 ? void 0 : _a.proxy_icon_url) && (react_1.default.createElement(Styles.FooterIcon, { src: embed.footer.proxy_icon_url })), (_b = embed.footer) === null || _b === void 0 ? void 0 :
            _b.text,
            embed.timestamp && (react_1.default.createElement(react_1.default.Fragment, null,
                " • ",
                (0, moment_1.default)(embed.timestamp).calendar()))))));
}
exports.default = Embed;
//# sourceMappingURL=index.js.map