"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VideoThumbnailPlayButton = exports.VideoThumbnailPlayButtonContainer = exports.VideoThumbnail = exports.VideoIframe = exports.MediaEmbed = exports.FooterIcon = exports.Footer = exports.ImageGridImageContainer = exports.Images = exports.Image = exports.FieldValue = exports.FieldName = exports.Field = exports.Fields = exports.Description = exports.Title = exports.AuthorName = exports.AuthorIcon = exports.Author = exports.Provider = exports.Content = exports.ContentAndThumbnail = exports.Embed = void 0;
const stitches_config_1 = require("../../Stitches/stitches.config");
const SvgFromUrl_1 = __importDefault(require("../../SvgFromUrl"));
exports.Embed = stitches_config_1.styled.withConfig({
    displayName: "embed",
    componentId: stitches_config_1.commonComponentId,
})("article", {
    padding: stitches_config_1.theme.space.xxl,
    paddingLeft: stitches_config_1.theme.space.xl,
    borderLeftWidth: 4,
    borderLeftStyle: "solid",
    borderLeftColor: stitches_config_1.theme.colors.backgroundTertiary,
    borderRadius: 3,
    backgroundColor: stitches_config_1.theme.colors.backgroundSecondary,
    width: "fit-content",
    gap: stitches_config_1.theme.space.large,
    display: "flex",
    flexDirection: "column",
    maxWidth: 520,
    variants: {
        thin: {
            true: {
                maxWidth: 432,
            },
        },
    },
});
exports.ContentAndThumbnail = stitches_config_1.styled.withConfig({
    displayName: "embed-content-and-thumbnail",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    display: "flex",
    gap: stitches_config_1.theme.space.xxl,
    variants: {
        hasLargeThumbnail: {
            true: {
                flexDirection: "column",
                maxWidth: 432,
            },
        },
    },
});
exports.Content = stitches_config_1.styled.withConfig({
    displayName: "embed-content",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    display: "grid",
    gap: stitches_config_1.theme.space.large,
});
exports.Provider = stitches_config_1.styled.withConfig({
    displayName: "embed-provider",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    fontSize: stitches_config_1.theme.fontSizes.s,
    color: stitches_config_1.theme.colors.interactiveNormal,
});
exports.Author = stitches_config_1.styled.withConfig({
    displayName: "embed-author",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    fontSize: stitches_config_1.theme.fontSizes.m,
    fontWeight: 600,
    display: "inline-grid",
    gridTemplateColumns: "auto 1fr",
    alignItems: "center",
    gap: stitches_config_1.theme.space.large,
    color: stitches_config_1.theme.colors.primaryOpacity100,
});
exports.AuthorIcon = stitches_config_1.styled.withConfig({
    displayName: "embed-author-icon",
    componentId: stitches_config_1.commonComponentId,
})("img", {
    width: 24,
    height: 24,
    borderRadius: "100%",
});
exports.AuthorName = stitches_config_1.styled.withConfig({
    displayName: "embed-author-name",
    componentId: stitches_config_1.commonComponentId,
})("span", {
    overflow: "hidden",
    whiteSpace: "nowrap",
    textOverflow: "ellipsis",
    display: "inline-block",
    color: stitches_config_1.theme.colors.primaryOpacity100,
    a: {
        color: stitches_config_1.theme.colors.primaryOpacity100,
        textDecoration: "none",
        "&:hover": {
            textDecoration: "underline",
        },
    },
});
exports.Title = stitches_config_1.styled.withConfig({
    displayName: "embed-title",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    fontSize: stitches_config_1.theme.fontSizes.l,
    fontWeight: 600,
    color: stitches_config_1.theme.colors.primaryOpacity100,
    variants: {
        link: {
            true: {
                cursor: "pointer",
                textDecoration: "none",
                color: stitches_config_1.theme.colors.link,
                "&:hover": {
                    textDecoration: "underline",
                },
            },
        },
    },
});
exports.Description = stitches_config_1.styled.withConfig({
    displayName: "embed-description",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    fontSize: stitches_config_1.theme.fontSizes.m,
    whiteSpace: "pre-wrap",
    color: stitches_config_1.theme.colors.interactiveNormal,
});
exports.Fields = stitches_config_1.styled.withConfig({
    displayName: "embed-fields",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    display: "flex",
    flexDirection: "row",
    flexWrap: "wrap",
    marginTop: stitches_config_1.theme.space.small,
    gap: stitches_config_1.theme.space.large,
});
exports.Field = stitches_config_1.styled.withConfig({
    displayName: "embed-field",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    flex: 0,
    maxWidth: 506,
    flexBasis: "100%",
    variants: {
        inline: {
            true: {
                width: "fit-content",
                flexBasis: "30%",
            },
        },
    },
});
exports.FieldName = stitches_config_1.styled.withConfig({
    displayName: "embed-field-name",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    fontSize: stitches_config_1.theme.fontSizes.m,
    marginBottom: stitches_config_1.theme.space.small,
    fontWeight: 600,
    color: stitches_config_1.theme.colors.primaryOpacity100,
});
exports.FieldValue = stitches_config_1.styled.withConfig({
    displayName: "embed-field-value",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    fontSize: stitches_config_1.theme.fontSizes.m,
    fontWeight: 400,
    whiteSpace: "pre-wrap",
    color: stitches_config_1.theme.colors.interactiveNormal,
});
exports.Image = stitches_config_1.styled.withConfig({
    displayName: "embed-field-image",
    componentId: stitches_config_1.commonComponentId,
})("img", {
    borderRadius: 3,
    cursor: "pointer",
    variants: {
        withMargin: {
            true: {
                marginTop: stitches_config_1.theme.space.large,
            },
        },
    },
});
exports.Images = stitches_config_1.styled.withConfig({
    displayName: "embed-field-images",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    display: "grid",
    gap: stitches_config_1.theme.space.small,
    borderRadius: 3,
    overflow: "hidden",
    img: {
        height: "100%",
        width: "100%",
        objectFit: "cover",
    },
    variants: {
        nImages: {
            1: {},
            2: {
                gridTemplateColumns: "1fr 1fr",
            },
            3: {
                gridTemplateColumns: "1fr 1fr",
                gridTemplateRows: "calc((300px - 4px) / 2) calc((300px - 4px) / 2)",
                "& > *:first-child": {
                    gridRow: "span 2",
                },
            },
            4: {
                gridTemplateColumns: "1fr 1fr",
                gridTemplateRows: "calc((300px - 4px) / 2) calc((300px - 4px) / 2)",
            },
        },
    },
});
exports.ImageGridImageContainer = stitches_config_1.styled.withConfig({
    displayName: "embed-image-grid-image-container",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    overflow: "hidden",
    display: "flex",
    justifyContent: "center",
    alignItems: "center",
});
exports.Footer = stitches_config_1.styled.withConfig({
    displayName: "embed-footer",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    fontSize: stitches_config_1.theme.fontSizes.s,
    display: "flex",
    alignItems: "center",
    color: stitches_config_1.theme.colors.interactiveNormal,
});
exports.FooterIcon = stitches_config_1.styled.withConfig({
    displayName: "embed-footer-icon",
    componentId: stitches_config_1.commonComponentId,
})("img", {
    borderRadius: "100%",
    width: 20,
    height: 20,
    marginRight: stitches_config_1.theme.space.large,
});
exports.MediaEmbed = stitches_config_1.styled.withConfig({
    displayName: "media-embed",
    componentId: stitches_config_1.commonComponentId,
})("img", {
    borderRadius: 3,
    cursor: "pointer",
});
exports.VideoIframe = stitches_config_1.styled.withConfig({
    displayName: "video-iframe",
    componentId: stitches_config_1.commonComponentId,
})("iframe", {
    border: "none",
    borderRadius: 3,
});
exports.VideoThumbnail = stitches_config_1.styled.withConfig({
    displayName: "video-thumbnail",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    borderRadius: 3,
    backgroundSize: "cover",
    position: "relative",
    cursor: "pointer",
});
exports.VideoThumbnailPlayButtonContainer = stitches_config_1.styled.withConfig({
    displayName: "video-thumbnail-play-button-container",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    position: "absolute",
    top: "50%",
    left: "50%",
    width: 40,
    height: 40,
    translate: "-50% -50%",
    borderRadius: "100%",
    display: "flex",
    alignItems: "center",
    justifyContent: "center",
    backgroundColor: stitches_config_1.theme.colors.transparentBlack,
});
exports.VideoThumbnailPlayButton = stitches_config_1.styled.withConfig({
    displayName: "video-thumbnail-play-button",
    componentId: stitches_config_1.commonComponentId,
})(SvgFromUrl_1.default, {
    opacity: 0.6,
    "&:hover": {
        opacity: 1,
    },
});
//# sourceMappingURL=style.js.map