"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const moment_1 = __importDefault(require("moment/moment"));
const Message_1 = __importDefault(require("../Message"));
const Styles = __importStar(require("./style"));
const v10_1 = require("discord-api-types/v10");
const Tooltip_1 = __importDefault(require("../Tooltip"));
const SvgFromUrl_1 = __importDefault(require("../SvgFromUrl"));
const render_1 = __importStar(require("../markdown/render"));
const Attachment_1 = __importDefault(require("./Attachment"));
const Sticker_1 = __importDefault(require("./Sticker"));
const Embed_1 = __importDefault(require("./Embed"));
const Reactions_1 = __importDefault(require("../Message/Reactions"));
const ThreadButton_1 = __importDefault(require("./Thread/ThreadButton"));
const Components_1 = __importDefault(require("../Message/Components"));
const getDisplayName_1 = __importDefault(require("../utils/getDisplayName"));
const Edited = (0, react_1.memo)((props) => {
    return (react_1.default.createElement(Tooltip_1.default, { overlay: (0, moment_1.default)(props.editedAt).format("LLLL"), placement: "top", mouseEnterDelay: 1 },
        react_1.default.createElement(Styles.Edited, null, "(edited)")));
});
function ReplyIcon({ message }) {
    var _a;
    if (message.interaction)
        return react_1.default.createElement(Styles.ReplyIcon, { width: 20, height: 20, svg: "IconCommand" });
    if (((_a = message.sticker_items) === null || _a === void 0 ? void 0 : _a.length) > 0)
        return react_1.default.createElement(Styles.ReplyIcon, { width: 20, height: 20, svg: "IconSticker" });
    if (message.attachments.length > 0 || message.embeds.length > 0)
        return react_1.default.createElement(Styles.ReplyIcon, { width: 20, height: 20, svg: "IconAttachment" });
    return null;
}
function MessageAccessories({ children, active }) {
    if (!active || !children || react_1.Children.count(children) === 0)
        return react_1.default.createElement(react_1.default.Fragment, null);
    return react_1.default.createElement(Styles.MessageAccessories, null, children);
}
function ContentCore(props) {
    if (!props.showTooltip)
        return react_1.default.createElement(react_1.default.Fragment, null, props.children);
    return (react_1.default.createElement(Tooltip_1.default, { overlay: react_1.default.createElement(Styles.ContentMessageTooltip, null,
            react_1.default.createElement(Message_1.default, { message: props.referencedMessage, isFirstMessage: true })), placement: "top", trigger: ["click"] }, props.children));
}
function Content(props) {
    var _a, _b, _c, _d, _e, _f, _g;
    const dominantAccessoryText = (0, react_1.useMemo)(() => {
        var _a;
        if (!props.isReplyContent)
            return null;
        if (props.message.interaction)
            return "Click to see command";
        if (((_a = props.message.sticker_items) === null || _a === void 0 ? void 0 : _a.length) > 0)
            return "Click to see sticker";
        if (props.message.attachments.length > 0 || props.message.embeds.length > 0)
            return "Click to see attachment";
        return null;
    }, [props.message.attachments, props.message.stickers, props.isReplyContent]);
    const embedImages = (0, react_1.useMemo)(() => {
        if (!props.message.embeds ||
            props.message.embeds.length <= 1 ||
            props.message.embeds[0].url === undefined)
            return [];
        if (!props.message.embeds.every((e) => e.url !== undefined && props.message.embeds[0].url === e.url))
            return [];
        const images = props.message.embeds
            .reduce((acc, embed) => [...acc, embed.image], [])
            .filter((i) => i !== null && i !== undefined);
        if (images.length === 0)
            return [];
        return images;
    }, [props.message.embeds]);
    if (props.message.flags & v10_1.MessageFlags.Loading) {
        const fifteenMinutes = 15 * 60 * 1000;
        if (Date.now() - new Date(props.message.timestamp).getTime() >
            fifteenMinutes)
            return (react_1.default.createElement(Styles.FailedInteraction, null,
                react_1.default.createElement(SvgFromUrl_1.default, { width: 16, height: 16, svg: "IconDanger" }),
                react_1.default.createElement("span", null, "The application did not respond")));
        return (react_1.default.createElement(Styles.DeferredContent, null,
            react_1.default.createElement(Styles.TypingIndicator, { width: 25.5, height: 7, style: { marginRight: 5 } },
                react_1.default.createElement("g", null,
                    react_1.default.createElement(Styles.TypingIndicatorCircle1, { cx: "3.5", cy: "3.5", r: "3.5", fill: "currentColor" }),
                    react_1.default.createElement(Styles.TypingIndicatorCircle2, { cx: "12.25", cy: "3.5", r: "3.5", fill: "currentColor" }),
                    react_1.default.createElement(Styles.TypingIndicatorCircle3, { cx: "21", cy: "3.5", r: "3.5", fill: "currentColor" }))),
            (0, getDisplayName_1.default)(props.message.author),
            " is thinking..."));
    }
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Styles.Base, { isReplyContent: props.isReplyContent },
            react_1.default.createElement(ContentCore, { referencedMessage: props.message, showTooltip: props.isReplyContent },
                react_1.default.createElement(Styles.ContentContainer, { isReplyContent: props.isReplyContent }, props.message.content.length > 0 ? (react_1.default.createElement(react_1.default.Fragment, null,
                    props.message.webhook_id !== undefined ? (react_1.default.createElement(render_1.LinkMarkdown, { mentions: props.message.mentions }, props.message.content)) : (react_1.default.createElement(render_1.default, { mentions: props.message.mentions }, props.message.content)),
                    props.message.edited_timestamp && (react_1.default.createElement(Edited, { editedAt: props.message.edited_timestamp })))) : (react_1.default.createElement(Styles.ReplyAccessoryText, null, dominantAccessoryText)))),
            props.isReplyContent && react_1.default.createElement(ReplyIcon, { message: props.message })),
        !props.isReplyContent && (react_1.default.createElement(MessageAccessories, { active: ((_a = props.message.reactions) === null || _a === void 0 ? void 0 : _a.length) > 0 ||
                props.message.attachments.length > 0 ||
                ((_b = props.message.sticker_items) === null || _b === void 0 ? void 0 : _b.length) > 0 ||
                props.message.thread !== undefined ||
                ((_c = props.message.embeds) === null || _c === void 0 ? void 0 : _c.length) > 0 ||
                ((_d = props.message.components) === null || _d === void 0 ? void 0 : _d.length) > 0 },
            props.message.attachments.map((attachment) => (react_1.default.createElement(Attachment_1.default, { key: attachment.url, attachment: attachment }))), (_e = props.message.sticker_items) === null || _e === void 0 ? void 0 :
            _e.map((sticker) => (react_1.default.createElement(Sticker_1.default, { key: sticker.id, sticker: sticker }))),
            embedImages.length > 0 ? (react_1.default.createElement(Embed_1.default, { key: props.message.embeds[0].url, embed: props.message.embeds[0], images: embedImages })) : (props.message.embeds.map((embed) => (react_1.default.createElement(Embed_1.default, { key: embed.url, embed: embed, images: undefined })))),
            ((_f = props.message.reactions) === null || _f === void 0 ? void 0 : _f.length) > 0 && (react_1.default.createElement(Reactions_1.default, { reactions: props.message.reactions })),
            ((_g = props.message.components) === null || _g === void 0 ? void 0 : _g.length) > 0 && (react_1.default.createElement(Components_1.default, { components: props.message.components, message: props.message })),
            !props.noThreadButton && props.message.thread && (react_1.default.createElement(ThreadButton_1.default, { hasReply: props.message.referenced_message !== undefined, thread: props.message.thread, messageId: props.message.id, messageContent: props.message.content, messageType: props.message.type }))))));
}
exports.default = (0, react_1.memo)(Content);
//# sourceMappingURL=index.js.map