"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypingIndicatorCircle3 = exports.TypingIndicatorCircle2 = exports.TypingIndicatorCircle1 = exports.TypingIndicator = exports.FailedInteraction = exports.Sticker = exports.StickerTooltip = exports.LottieStickerWrapper = exports.StickerTooltipIcon = exports.ReplyIcon = exports.SeeThreadButton = exports.ThreadButtonName = exports.ThreadButtonTopLine = exports.ThreadButton = exports.ThreadButtonContainer = exports.Edited = exports.DeferredContent = exports.MessageAccessories = exports.ReplyAccessoryText = exports.ContentContainer = exports.ContentMessageTooltip = exports.Base = void 0;
const stitches_config_1 = require("../Stitches/stitches.config");
const style_1 = require("../markdown/render/elements/code/style");
const SvgFromUrl_1 = __importDefault(require("../SvgFromUrl"));
exports.Base = stitches_config_1.styled.withConfig({
    displayName: "message-content",
    componentId: stitches_config_1.commonComponentId,
})("span", {
    color: stitches_config_1.theme.colors.primaryOpacity20,
    whiteSpace: "break-spaces",
    fontSize: stitches_config_1.theme.fontSizes.l,
    variants: {
        isReplyContent: {
            true: {
                fontSize: stitches_config_1.theme.fontSizes.m,
                opacity: 0.64,
                cursor: "pointer",
                whiteSpace: "nowrap",
                overflow: "hidden",
                textOverflow: "ellipsis",
                display: "flex",
                maxWidth: `calc(100% - ${stitches_config_1.theme.sizes.messageLeftPadding})`,
                alignItems: "center",
                "&:hover": {
                    opacity: 1,
                },
            },
        },
    },
});
exports.ContentMessageTooltip = stitches_config_1.styled.withConfig({
    displayName: "content-message-tooltip",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    maxWidth: "60vw",
});
exports.ContentContainer = stitches_config_1.styled.withConfig({
    displayName: "content-container",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    color: stitches_config_1.theme.colors.primaryOpacity80,
    fontWeight: 400,
    lineHeight: "1.375rem",
    variants: {
        isReplyContent: {
            true: {
                overflow: "hidden",
                textOverflow: "ellipsis",
                whiteSpace: "nowrap",
                flex: "0 1 auto",
                pointerEvents: "none",
                maxWidth: "25vw",
                [`${style_1.CodeBlock}`]: {
                    display: "inline",
                    padding: stitches_config_1.theme.space.xs,
                    fontSize: stitches_config_1.theme.fontSizes.s,
                    whiteSpace: "nowrap",
                },
            },
        },
    },
});
exports.ReplyAccessoryText = stitches_config_1.styled.withConfig({
    displayName: "content-reply-acessory-text",
    componentId: stitches_config_1.commonComponentId,
})("span", "span", {
    fontStyle: "italic",
});
exports.MessageAccessories = stitches_config_1.styled.withConfig({
    displayName: "message-accessories",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    display: "grid",
    paddingTop: stitches_config_1.theme.space.small,
    paddingBottom: stitches_config_1.theme.space.small,
    gridAutoFlow: "row",
    gridRowGap: `${stitches_config_1.theme.space.small}`,
    gridTemplateColumns: "repeat(auto-fill, minmax(100%, 1fr))",
});
exports.DeferredContent = stitches_config_1.styled.withConfig({
    displayName: "deferred-content",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    fontSize: stitches_config_1.theme.fontSizes.m,
    color: stitches_config_1.theme.colors.primaryOpacity80,
});
exports.Edited = stitches_config_1.styled.withConfig({
    displayName: "edited",
    componentId: stitches_config_1.commonComponentId,
})("span", {
    fontSize: stitches_config_1.theme.fontSizes.xs,
    marginLeft: stitches_config_1.theme.space.small,
    whiteSpace: "nowrap",
    color: stitches_config_1.theme.colors.textMuted,
});
exports.ThreadButtonContainer = stitches_config_1.styled.withConfig({
    displayName: "thread-button-container",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    marginTop: stitches_config_1.theme.space.small,
    width: "100%",
    display: "block",
});
exports.ThreadButton = stitches_config_1.styled.withConfig({
    displayName: "thread-button",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    boxSizing: "border-box",
    width: "fit-content",
    padding: stitches_config_1.theme.space.large,
    height: stitches_config_1.theme.sizes.threadButton,
    borderRadius: 4,
    backgroundColor: stitches_config_1.theme.colors.backgroundSecondary,
});
exports.ThreadButtonTopLine = stitches_config_1.styled.withConfig({
    displayName: "thread-button-top-line",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    display: "flex",
    fontSize: stitches_config_1.theme.fontSizes.m,
    fontWeight: 600,
});
exports.ThreadButtonName = stitches_config_1.styled.withConfig({
    displayName: "thread-button-name",
    componentId: stitches_config_1.commonComponentId,
})("span", {
    whiteSpace: "nowrap",
    overflow: "hidden",
    textOverflow: "ellipsis",
    color: stitches_config_1.theme.colors.primaryOpacity100,
});
exports.SeeThreadButton = stitches_config_1.styled.withConfig({
    displayName: "see-thread-button",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    marginLeft: stitches_config_1.theme.space.large,
    color: stitches_config_1.theme.colors.link,
    whiteSpace: "nowrap",
    cursor: "pointer",
    "&:hover": {
        textDecoration: "underline",
    },
});
exports.ReplyIcon = stitches_config_1.styled.withConfig({
    displayName: "reply-icon",
    componentId: stitches_config_1.commonComponentId,
})(SvgFromUrl_1.default, {
    marginLeft: stitches_config_1.theme.space.small,
    width: 20,
    height: 20,
});
exports.StickerTooltipIcon = stitches_config_1.styled.withConfig({
    displayName: "sticker-tooltip-icon",
    componentId: stitches_config_1.commonComponentId,
})(SvgFromUrl_1.default, {
    marginRight: stitches_config_1.theme.space.small,
});
exports.LottieStickerWrapper = stitches_config_1.styled.withConfig({
    displayName: "lottie-sticker-wrapper",
    componentId: stitches_config_1.commonComponentId,
})("span", {
    width: "fit-content",
});
exports.StickerTooltip = stitches_config_1.styled.withConfig({
    displayName: "sticker-tooltip",
    componentId: stitches_config_1.commonComponentId,
})("span", {
    display: "flex",
    alignItems: "center",
    whiteSpace: "break-spaces",
});
exports.Sticker = stitches_config_1.styled.withConfig({
    displayName: "sticker",
    componentId: stitches_config_1.commonComponentId,
})("img", {
    objectFit: "contain",
});
exports.FailedInteraction = stitches_config_1.styled.withConfig({
    displayName: "failed-interaction",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    fontSize: stitches_config_1.theme.fontSizes.m,
    color: stitches_config_1.theme.colors.danger,
    display: "flex",
    alignItems: "center",
    gap: stitches_config_1.theme.space.large,
});
exports.TypingIndicator = stitches_config_1.styled.withConfig({
    displayName: "typing-indicator",
    componentId: stitches_config_1.commonComponentId,
})("svg", {
    color: stitches_config_1.theme.colors.primaryOpacity100,
});
const typingIndicatorKeyframes = (0, stitches_config_1.keyframes)({
    "0%": {
        scale: 0.9,
        opacity: 0.3,
    },
    "25%": {
        scale: 1,
        opacity: 1,
    },
    "50%, 100%": {
        scale: 0.9,
        opacity: 0.3,
    },
});
const typingIndicatorCircleCommon = {
    animationName: typingIndicatorKeyframes.toString(),
    animationIterationCount: "infinite",
    animationDuration: "1.2s",
};
exports.TypingIndicatorCircle1 = stitches_config_1.styled.withConfig({
    displayName: "typing-indicator-circle-1",
    componentId: stitches_config_1.commonComponentId,
})("circle", Object.assign(Object.assign({}, typingIndicatorCircleCommon), { transformOrigin: "3.5px center", animationDelay: "0.1s" }));
exports.TypingIndicatorCircle2 = stitches_config_1.styled.withConfig({
    displayName: "typing-indicator-circle-2",
    componentId: stitches_config_1.commonComponentId,
})("circle", Object.assign(Object.assign({}, typingIndicatorCircleCommon), { transformOrigin: "12.25px center", animationDelay: "0.2s" }));
exports.TypingIndicatorCircle3 = stitches_config_1.styled.withConfig({
    displayName: "typing-indicator-circle-3",
    componentId: stitches_config_1.commonComponentId,
})("circle", Object.assign(Object.assign({}, typingIndicatorCircleCommon), { transformOrigin: "21px center", animationDelay: "0.3s" }));
//# sourceMappingURL=style.js.map