"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Twemoji = void 0;
const Styles = __importStar(require("./style"));
const react_1 = __importStar(require("react"));
const react_easy_emoji_1 = __importDefault(require("react-easy-emoji"));
const style_1 = require("./style");
const Tooltip_1 = __importDefault(require("../Tooltip"));
const emojiData_1 = require("../emojiData");
const stitches_config_1 = require("../Stitches/stitches.config");
function EmojiTooltip({ children, disabled, key, tooltipContent, }) {
    if (disabled)
        return react_1.default.createElement(react_1.default.Fragment, null, children);
    return (react_1.default.createElement(Tooltip_1.default, { key: key, placement: "top", overlay: `:${tooltipContent}:`, mouseEnterDelay: 0.6, mouseLeaveDelay: 0 }, children));
}
function Emoji(_a) {
    var { src, disableTooltip, emojiName, enlarged } = _a, props = __rest(_a, ["src", "disableTooltip", "emojiName", "enlarged"]);
    const defaultEmoji = (0, react_1.useMemo)(() => (0, emojiData_1.findDefaultEmojiByUnicode)(emojiName), [emojiName]);
    if (src !== undefined)
        return (react_1.default.createElement(EmojiTooltip, { tooltipContent: emojiName, disabled: disableTooltip },
            react_1.default.createElement(Styles.Emoji, Object.assign({}, props, { enlarged: enlarged, src: src, alt: emojiName }))));
    if (defaultEmoji === undefined)
        return react_1.default.createElement(react_1.default.Fragment, null, emojiName);
    return (0, react_easy_emoji_1.default)(defaultEmoji.emoji, (code, string, key) => (react_1.default.createElement(react_1.Fragment, { key: key },
        react_1.default.createElement(EmojiTooltip, { tooltipContent: defaultEmoji.keywords[0], disabled: disableTooltip },
            react_1.default.createElement(Styles.Emoji, Object.assign({}, props, { enlarged: enlarged, src: `https://cdn.jsdelivr.net/gh/twitter/twemoji/assets/svg/${code}.svg`, alt: string }))))));
}
exports.Twemoji = stitches_config_1.styled.withConfig({
    displayName: "twemoji",
    componentId: stitches_config_1.commonComponentId,
})(Emoji, style_1.emojiCss);
exports.default = Emoji;
//# sourceMappingURL=index.js.map