"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Styles = __importStar(require("./style"));
const react_1 = __importDefault(require("react"));
const SvgFromUrl_1 = __importDefault(require("../../SvgFromUrl"));
const v10_1 = require("discord-api-types/v10");
const Emoji_1 = __importDefault(require("../../Emoji"));
const ConfigContext_1 = require("../../core/ConfigContext");
const buttonStyleMap = {
    [v10_1.ButtonStyle.Primary]: "primary",
    [v10_1.ButtonStyle.Secondary]: "secondary",
    [v10_1.ButtonStyle.Link]: "secondary",
    [v10_1.ButtonStyle.Danger]: "danger",
    [v10_1.ButtonStyle.Success]: "success",
};
function ButtonComponent({ button, message }) {
    const { messageComponentButtonOnClick } = (0, ConfigContext_1.useConfig)();
    if ("url" in button) {
        return (react_1.default.createElement(Styles.ButtonComponent, { as: "a", href: button.url, buttonStyle: buttonStyleMap[button.style] },
            react_1.default.createElement(Styles.ButtonComponentContent, null,
                button.emoji && (react_1.default.createElement(Emoji_1.default, { emojiName: button.emoji.name, src: button.emoji.id &&
                        `https://cdn.discordapp.com/emojis/${button.emoji.id}.${button.emoji.animated ? "gif" : "png"}` })),
                button.label,
                react_1.default.createElement(SvgFromUrl_1.default, { width: 16, height: 16, svg: "IconLinkExternal" }))));
    }
    return (react_1.default.createElement(Styles.ButtonComponent, { buttonStyle: buttonStyleMap[button.style], onClick: () => messageComponentButtonOnClick === null || messageComponentButtonOnClick === void 0 ? void 0 : messageComponentButtonOnClick(message, button.custom_id) },
        react_1.default.createElement(Styles.ButtonComponentContent, null,
            button.emoji && (react_1.default.createElement(Emoji_1.default, { emojiName: button.emoji.name, src: button.emoji.id &&
                    `https://cdn.discordapp.com/emojis/${button.emoji.id}.${button.emoji.animated ? "gif" : "png"}` })),
            button.label)));
}
exports.default = ButtonComponent;
//# sourceMappingURL=ButtonComponent.js.map