"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActionRow = exports.ButtonComponentContent = exports.ButtonComponent = exports.Components = void 0;
const stitches_config_1 = require("../../Stitches/stitches.config");
exports.Components = stitches_config_1.styled.withConfig({
    displayName: "message-components",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    display: "flex",
    flexDirection: "column",
    gap: stitches_config_1.theme.space.large,
});
exports.ButtonComponent = stitches_config_1.styled.withConfig({
    displayName: "button-component",
    componentId: stitches_config_1.commonComponentId,
})("button", {
    padding: `${stitches_config_1.theme.space.xs} ${stitches_config_1.theme.space.xxl}`,
    cursor: "pointer",
    fontWeight: 500,
    fontSize: stitches_config_1.theme.fontSizes.m,
    lineHeight: "16px",
    border: "none",
    borderRadius: 3,
    color: stitches_config_1.theme.colors.primaryOpacity100,
    display: "block",
    transition: "background-color .17s ease",
    textDecoration: "none",
    fontFamily: stitches_config_1.theme.fonts.main,
    height: 32,
    boxSizing: "border-box",
    variants: {
        buttonStyle: {
            primary: {
                backgroundColor: stitches_config_1.theme.colors.buttonPrimaryBackground,
                "&:hover": {
                    backgroundColor: stitches_config_1.theme.colors.buttonPrimaryHoverBackground,
                },
            },
            secondary: {
                backgroundColor: stitches_config_1.theme.colors.buttonSecondaryBackground,
                "&:hover": {
                    backgroundColor: stitches_config_1.theme.colors.buttonSecondaryHoverBackground,
                },
            },
            danger: {
                backgroundColor: stitches_config_1.theme.colors.buttonDangerBackground,
                "&:hover": {
                    backgroundColor: stitches_config_1.theme.colors.buttonDangerHoverBackground,
                },
            },
            success: {
                backgroundColor: stitches_config_1.theme.colors.buttonSuccessBackground,
                "&:hover": {
                    backgroundColor: stitches_config_1.theme.colors.buttonSuccessHoverBackground,
                },
            },
        },
    },
});
exports.ButtonComponentContent = stitches_config_1.styled.withConfig({
    displayName: "button-component-content",
    componentId: stitches_config_1.commonComponentId,
})("span", {
    verticalAlign: "middle",
    display: "flex",
    flexDirection: "row",
    alignItems: "center",
    justifyContent: "center",
    gap: stitches_config_1.theme.space.medium,
    height: '100%'
});
exports.ActionRow = stitches_config_1.styled.withConfig({
    displayName: "action-row",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    display: "flex",
    flexDirection: "row",
    gap: stitches_config_1.theme.space.large,
});
//# sourceMappingURL=style.js.map