"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = __importStar(require("react"));
const react_1 = require("react");
const ChatTag_1 = __importDefault(require("../ChatTag"));
const RoleIcon_1 = __importDefault(require("./RoleIcon"));
const getAvatar_1 = __importDefault(require("../utils/getAvatar"));
const Styles = __importStar(require("./style/author"));
const ConfigContext_1 = require("../core/ConfigContext");
const getDisplayName_1 = __importDefault(require("../utils/getDisplayName"));
function MessageAuthor({ onlyShowUsername, author, avatarAnimated, crossPost, referenceGuild, }) {
    var _a;
    const { resolveRole } = (0, ConfigContext_1.useConfig)();
    const isGuildMember = "joined_at" in author;
    const user = isGuildMember ? author.user : author;
    const displayName = isGuildMember
        ? (_a = author.nick) !== null && _a !== void 0 ? _a : (0, getDisplayName_1.default)(author.user)
        : (0, getDisplayName_1.default)(author);
    const dominantRoleIconRole = (0, react_1.useMemo)(() => {
        if (!isGuildMember || !resolveRole)
            return null;
        const [role] = author.roles
            .map((id) => resolveRole(id))
            .filter((role) => role !== null && (role.icon !== null || role.unicode_emoji !== null))
            .sort((a, b) => b.position - a.position);
        if (!role)
            return null;
        return role;
    }, [isGuildMember, resolveRole, author]);
    const dominantRoleColor = (0, react_1.useMemo)(() => {
        if (!isGuildMember || !resolveRole)
            return null;
        const [role] = author.roles
            .map((id) => resolveRole(id))
            .filter((r) => r !== undefined && r.color !== 0)
            .sort((a, b) => b.position - a.position);
        const color = role === null || role === void 0 ? void 0 : role.color;
        if (!color)
            return null;
        return color > 0 ? `#${color.toString(16).padStart(6, "0")}` : undefined;
    }, [isGuildMember, resolveRole, author]);
    if (onlyShowUsername) {
        return (React.createElement(Styles.MessageAuthor, null,
            React.createElement(Styles.Username, { style: { color: dominantRoleColor } }, displayName)));
    }
    return (React.createElement(Styles.MessageAuthor, null,
        React.createElement(Styles.Avatar, { src: (0, getAvatar_1.default)(user, {
                animated: avatarAnimated !== null && avatarAnimated !== void 0 ? avatarAnimated : false,
            }), draggable: false }),
        React.createElement(Styles.Username, { style: { color: dominantRoleColor } }, displayName),
        dominantRoleIconRole !== null && (React.createElement(RoleIcon_1.default, { role: dominantRoleIconRole })),
        React.createElement(ChatTag_1.default, { author: user, crosspost: crossPost, referenceGuild: referenceGuild })));
}
exports.default = MessageAuthor;
//# sourceMappingURL=MessageAuthor.js.map