"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Styles = __importStar(require("./style"));
const react_1 = __importStar(require("react"));
const Tooltip_1 = __importDefault(require("../../Tooltip"));
const emojiData_1 = require("../../emojiData");
function Reaction(props) {
    const emojiUrl = (0, react_1.useMemo)(() => {
        if (props.reaction.emoji.id === null)
            return null;
        return `https://cdn.discordapp.com/emojis/${props.reaction.emoji.id}.${props.reaction.emoji.animated ? "gif" : "webp"}?v=1&size=32&quality=lossless`;
    }, [props.reaction.emoji.id, props.reaction.emoji.animated]);
    const Emoji = (0, react_1.useCallback)(() => {
        var _a, _b, _c;
        const url = `https://cdn.discordapp.com/emojis/${props.reaction.emoji.id}.${props.reaction.emoji.animated ? "gif" : "webp"}?v=1&size=64&quality=lossless`;
        return (react_1.default.createElement(Styles.ReactionTooltip, null,
            props.reaction.emoji.id !== null ? (react_1.default.createElement(Styles.ReactionEmoji, { emojiName: props.reaction.emoji.name, src: url, disableTooltip: true, enlarged: true })) : (react_1.default.createElement(Styles.ReactionEmoji, { emojiName: props.reaction.emoji.name, disableTooltip: true, enlarged: true })),
            ":",
            props.reaction.emoji.id !== null
                ? props.reaction.emoji.name
                : (_c = (_b = (_a = (0, emojiData_1.findDefaultEmojiByUnicode)(props.reaction.emoji.name)) === null || _a === void 0 ? void 0 : _a.keywords) === null || _b === void 0 ? void 0 : _b[0]) !== null && _c !== void 0 ? _c : "unknown emoji",
            ":"));
    }, [
        props.reaction.emoji.animated,
        props.reaction.emoji.id,
        props.reaction.emoji.name,
    ]);
    return (react_1.default.createElement(Tooltip_1.default, { overlay: react_1.default.createElement(Emoji, null), placement: "top", mouseEnterDelay: 0.5 },
        react_1.default.createElement(Styles.Reaction, null,
            emojiUrl ? (react_1.default.createElement(Styles.ReactionEmoji, { src: emojiUrl, emojiName: props.reaction.emoji.name, disableTooltip: true })) : (react_1.default.createElement(Styles.ReactionEmoji, { emojiName: props.reaction.emoji.name, disableTooltip: true })),
            react_1.default.createElement(Styles.ReactionCount, null, props.reaction.count))));
}
exports.default = Reaction;
//# sourceMappingURL=Reaction.js.map