"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReactionCount = exports.Reaction = exports.ReactionEmoji = exports.ReactionTooltip = exports.Reactions = void 0;
const stitches_config_1 = require("../../Stitches/stitches.config");
const Emoji_1 = require("../../Emoji");
exports.Reactions = stitches_config_1.styled.withConfig({
    displayName: "reactions",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    display: "flex",
    flexWrap: "wrap",
    gap: stitches_config_1.theme.space.small,
    userSelect: "none",
});
exports.ReactionTooltip = stitches_config_1.styled.withConfig({
    displayName: "emoji-tooltip",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    display: "flex",
    alignItems: "center",
    gap: stitches_config_1.theme.space.large,
});
exports.ReactionEmoji = stitches_config_1.styled.withConfig({
    displayName: "reaction-emoji",
    componentId: stitches_config_1.commonComponentId,
})(Emoji_1.Twemoji, {
    width: 16,
    height: 16,
});
exports.Reaction = stitches_config_1.styled.withConfig({
    displayName: "reaction",
    componentId: stitches_config_1.commonComponentId,
})("span", {
    display: "flex",
    flexDirection: "row",
    alignItems: "center",
    padding: `${stitches_config_1.theme.space.small} ${stitches_config_1.theme.space.medium}`,
    borderRadius: 8,
    cursor: "not-allowed",
    backgroundColor: stitches_config_1.theme.colors.backgroundSecondary,
});
exports.ReactionCount = stitches_config_1.styled.withConfig({
    displayName: "reaction-count",
    componentId: stitches_config_1.commonComponentId,
})("span", {
    marginLeft: stitches_config_1.theme.space.medium,
    minWidth: 9,
    fontWeight: 500,
    fontSize: stitches_config_1.theme.fontSizes.m,
    color: stitches_config_1.theme.colors.primaryOpacity80,
});
//# sourceMappingURL=style.js.map