"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const Styles = __importStar(require("./style/message"));
const Tooltip_1 = __importDefault(require("../Tooltip"));
const webpCheck_1 = __importDefault(require("../utils/webpCheck"));
const lodash_1 = require("lodash");
const React = __importStar(require("react"));
const Emoji_1 = require("../Emoji");
class RoleIcon extends react_1.PureComponent {
    constructor() {
        super(...arguments);
        this.getRoleIcon = (0, lodash_1.memoize)((icon, roleId) => (0, webpCheck_1.default)(`https://cdn.discordapp.com/role-icons/${roleId}/${icon}.webp`));
    }
    render() {
        if (this.props.role === null ||
            (this.props.role.icon === null && this.props.role.unicode_emoji === null))
            return null;
        if (this.props.role.unicode_emoji !== null)
            return (React.createElement(Tooltip_1.default, { overlay: this.props.role.name, placement: "top" },
                React.createElement("span", null,
                    React.createElement(Styles.RoleIcon, { as: Emoji_1.Twemoji, disableTooltip: true, emojiName: this.props.role.unicode_emoji }, this.props.role.unicode_emoji))));
        const iconUrl = this.getRoleIcon(this.props.role.icon, this.props.role.id);
        return (React.createElement(Tooltip_1.default, { overlay: this.props.role.name, placement: "top" },
            React.createElement(Styles.RoleIcon, { src: iconUrl })));
    }
}
exports.default = RoleIcon;
//# sourceMappingURL=RoleIcon.js.map