"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const NormalMessage_1 = __importDefault(require("./variants/NormalMessage"));
const react_1 = __importStar(require("react"));
const MessageContainer_1 = __importDefault(require("./MessageContainer"));
const v10_1 = require("discord-api-types/v10");
const GuildMemberJoin_1 = __importDefault(require("./variants/GuildMemberJoin"));
const GuildDiscoveryRequalified_1 = __importDefault(require("./variants/GuildDiscoveryRequalified"));
const GuildDiscoveryGracePeriodInitialWarning_1 = __importDefault(require("./variants/GuildDiscoveryGracePeriodInitialWarning"));
const GuildDiscoveryGracePeriodFinalWarning_1 = __importDefault(require("./variants/GuildDiscoveryGracePeriodFinalWarning"));
const GuildDiscoveryDisqualified_1 = __importDefault(require("./variants/GuildDiscoveryDisqualified"));
const ChannelFollowAdd_1 = __importDefault(require("./variants/ChannelFollowAdd"));
const ChannelNameChange_1 = __importDefault(require("./variants/ChannelNameChange"));
const GuildBoost_1 = __importDefault(require("./variants/GuildBoost"));
const BoostTierUpgrade_1 = __importDefault(require("./variants/BoostTierUpgrade"));
const ChannelPinnedMessage_1 = __importDefault(require("./variants/ChannelPinnedMessage"));
const RecipientAdd_1 = __importDefault(require("./variants/RecipientAdd"));
const RecipientRemove_1 = __importDefault(require("./variants/RecipientRemove"));
const ThreadCreated_1 = __importDefault(require("./variants/ThreadCreated"));
const ConfigContext_1 = require("../core/ConfigContext");
function MessageTypeSwitch(props) {
    switch (props.message.type) {
        case v10_1.MessageType.ChannelPinnedMessage:
            return (react_1.default.createElement(ChannelPinnedMessage_1.default, { createdAt: props.message.timestamp, author: props.message.author }));
        case v10_1.MessageType.UserJoin:
            return (react_1.default.createElement(GuildMemberJoin_1.default, { createdAt: props.message.timestamp, author: props.message.author }));
        case v10_1.MessageType.GuildDiscoveryRequalified:
            return react_1.default.createElement(GuildDiscoveryRequalified_1.default, { createdAt: props.message.timestamp });
        case v10_1.MessageType.GuildBoostTier1:
        case v10_1.MessageType.GuildBoostTier2:
        case v10_1.MessageType.GuildBoostTier3:
            return (react_1.default.createElement(BoostTierUpgrade_1.default, { channelId: props.message.channel_id, content: props.message.content, createdAt: props.message.timestamp, author: props.message.author, type: props.message.type }));
        case v10_1.MessageType.GuildBoost:
            return (react_1.default.createElement(GuildBoost_1.default, { createdAt: props.message.timestamp, author: props.message.author, content: props.message.content }));
        case v10_1.MessageType.RecipientAdd:
            return (react_1.default.createElement(RecipientAdd_1.default, { createdAt: props.message.timestamp, author: props.message.author, target: props.message.mentions[0] }));
        case v10_1.MessageType.RecipientRemove:
            return (react_1.default.createElement(RecipientRemove_1.default, { createdAt: props.message.timestamp, author: props.message.author, target: props.message.mentions[0] }));
        case v10_1.MessageType.ChannelNameChange:
            return (react_1.default.createElement(ChannelNameChange_1.default, { createdAt: props.message.timestamp, author: props.message.author, content: props.message.content }));
        case v10_1.MessageType.ThreadCreated:
            return (react_1.default.createElement(ThreadCreated_1.default, { createdAt: props.message.timestamp, thread: props.message.thread, author: props.message.author, messageId: props.message.id, messageReference: props.message.message_reference, messageContent: props.message.content }));
        case v10_1.MessageType.Reply:
        case v10_1.MessageType.Default:
        case v10_1.MessageType.ChatInputCommand:
            return react_1.default.createElement(NormalMessage_1.default, Object.assign({}, props));
        case v10_1.MessageType.ChannelFollowAdd:
            return (react_1.default.createElement(ChannelFollowAdd_1.default, { createdAt: props.message.timestamp, author: props.message.author, content: props.message.content }));
        case v10_1.MessageType.GuildDiscoveryGracePeriodInitialWarning:
            return (react_1.default.createElement(GuildDiscoveryGracePeriodInitialWarning_1.default, { createdAt: props.message.timestamp }));
        case v10_1.MessageType.GuildDiscoveryGracePeriodFinalWarning:
            return (react_1.default.createElement(GuildDiscoveryGracePeriodFinalWarning_1.default, { createdAt: props.message.timestamp }));
        case v10_1.MessageType.GuildDiscoveryDisqualified:
            return react_1.default.createElement(GuildDiscoveryDisqualified_1.default, { createdAt: props.message.timestamp });
        case v10_1.MessageType.ContextMenuCommand:
            return react_1.default.createElement(NormalMessage_1.default, Object.assign({}, props, { isContextMenuInteraction: true }));
        case v10_1.MessageType.ThreadStarterMessage:
            return (react_1.default.createElement(NormalMessage_1.default, Object.assign({}, props, { message: props.message.referenced_message, noThreadButton: true })));
        default: {
            // todo: lock behind a debug mode
            const errorMessage = Object.assign(Object.assign({}, props.message), { type: v10_1.MessageType.Default, content: `Unknown message type \`${props.message.type}\`\n\n\`\`\`json\n${JSON.stringify(props.message, null, 2)}\n\`\`\`` });
            return (react_1.default.createElement(NormalMessage_1.default, { message: errorMessage, isFirstMessage: props.isFirstMessage, isHovered: props.isHovered }));
        }
    }
}
function Message(props) {
    var _a;
    const { messageButtons } = (0, ConfigContext_1.useConfig)();
    const buttonOptions = (_a = messageButtons === null || messageButtons === void 0 ? void 0 : messageButtons(props.message)) !== null && _a !== void 0 ? _a : [];
    if (props.showButtons)
        return (react_1.default.createElement(MessageContainer_1.default, { buttons: buttonOptions },
            react_1.default.createElement(MessageTypeSwitch, Object.assign({}, props))));
    return react_1.default.createElement(MessageTypeSwitch, Object.assign({}, props));
}
exports.default = (0, react_1.memo)(Message);
//# sourceMappingURL=index.js.map