"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Avatar = exports.Username = exports.MessageAuthor = void 0;
const stitches_config_1 = require("../../Stitches/stitches.config");
exports.MessageAuthor = stitches_config_1.styled.withConfig({
    displayName: "message-author",
    componentId: stitches_config_1.commonComponentId,
})("span", {
    display: "inline-flex",
});
exports.Username = stitches_config_1.styled.withConfig({
    displayName: "message-author-username",
    componentId: stitches_config_1.commonComponentId,
})("span", {
    color: stitches_config_1.theme.colors.primaryOpacity100,
    fontWeight: 500,
    fontSize: stitches_config_1.theme.fontSizes.l,
    display: "inline",
    verticalAlign: "baseline",
    whiteSpace: "nowrap",
    lineHeight: `1.375rem`,
});
exports.Avatar = stitches_config_1.styled.withConfig({
    displayName: "message-author-avatar",
    componentId: stitches_config_1.commonComponentId,
})("img", {
    position: "absolute",
    left: `calc(${stitches_config_1.theme.sizes.messageLeftPadding} / 2)`,
    transform: "translateX(-50%)",
    marginTop: "calc(4px - .125rem)",
    borderRadius: "100%",
    width: 40,
    height: 40,
    zIndex: 1,
});
//# sourceMappingURL=author.js.map