"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const MessageAuthor_1 = __importDefault(require("../MessageAuthor"));
const Content_1 = __importDefault(require("../../Content"));
const moment_1 = __importDefault(require("moment"));
const Tooltip_1 = __importDefault(require("../../Tooltip"));
const getAvatar_1 = __importDefault(require("../../utils/getAvatar"));
const LargeTimestamp_1 = __importDefault(require("../LargeTimestamp"));
const ChatTag_1 = __importDefault(require("../../ChatTag"));
const Styles = __importStar(require("../style/message"));
const v10_1 = require("discord-api-types/v10");
const ConfigContext_1 = require("../../core/ConfigContext");
const getDisplayName_1 = __importDefault(require("../../utils/getDisplayName"));
function getMiniAvatarUrl(referencedMessage, interaction) {
    const getAvatarSettings = {
        size: 16,
        animated: false,
    };
    if (interaction !== undefined)
        return (0, getAvatar_1.default)(interaction.user, getAvatarSettings);
    if (referencedMessage !== undefined && referencedMessage !== null)
        return (0, getAvatar_1.default)(referencedMessage.author, getAvatarSettings);
    return null;
}
const ReplyInfo = (0, react_1.memo)((props) => {
    var _a;
    const miniAvatarUrl = (0, react_1.useMemo)(() => getMiniAvatarUrl(props.referencedMessage, props.interaction), [props.referencedMessage, props.interaction]);
    const { resolveRole, resolveChannel, resolveMember } = (0, ConfigContext_1.useConfig)();
    const miniUserName = (0, react_1.useMemo)(() => {
        var _a;
        if (!props.interaction && !props.referencedMessage)
            return null;
        const user = props.interaction !== undefined
            ? props.interaction.user
            : props.referencedMessage.author;
        if (!resolveChannel)
            return (0, getDisplayName_1.default)(user);
        const channel = resolveChannel(props.channelId);
        if (!channel || !("guild_id" in channel))
            return (0, getDisplayName_1.default)(user);
        const guildMember = resolveMember(props.referencedMessage.author.id, channel.guild_id);
        if (!guildMember)
            return (0, getDisplayName_1.default)(user);
        return (_a = guildMember.nick) !== null && _a !== void 0 ? _a : (0, getDisplayName_1.default)(guildMember.user);
    }, [props.referencedMessage, props.interaction, resolveChannel]);
    const miniUserNameColorHex = (0, react_1.useMemo)(() => {
        if (!props.referencedMessage)
            return null;
        const channel = resolveChannel(props.referencedMessage.channel_id);
        if (!channel || !("guild_id" in channel))
            return null;
        const guildMember = resolveMember(props.referencedMessage.author.id, channel.guild_id);
        if (!guildMember)
            return null;
        const [role] = guildMember.roles
            .map((id) => resolveRole(id))
            .filter((r) => r !== undefined && r.color !== 0)
            .sort((a, b) => b.position - a.position);
        const color = role === null || role === void 0 ? void 0 : role.color;
        if (!color)
            return null;
        return color > 0 ? `#${color.toString(16).padStart(6, "0")}` : undefined;
    }, [resolveRole]);
    const unknownReply = !props.referencedMessage && !props.interaction;
    return (react_1.default.createElement(Styles.ReplyInfo, null,
        react_1.default.createElement(Styles.ReplySpine, null),
        unknownReply ? (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(Styles.UnknownReplyIcon, { width: 12, height: 12, svg: "IconUnknownReply" }),
            react_1.default.createElement(Styles.UnknownReply, null, "Original message was deleted or is unknown."))) : (react_1.default.createElement(Styles.ReplyUser, null,
            react_1.default.createElement(Styles.MiniUserAvatar, { src: miniAvatarUrl }),
            props.referencedMessage && (react_1.default.createElement(ChatTag_1.default, { author: props.referencedMessage.author, crosspost: !!(props.referencedMessage.flags & (1 << 1)), referenceGuild: (_a = props.referencedMessage.message_reference) === null || _a === void 0 ? void 0 : _a.guild_id })),
            react_1.default.createElement(Styles.MiniUserName, { style: { color: miniUserNameColorHex } },
                props.mentioned && "@",
                miniUserName))),
        props.referencedMessage ? (react_1.default.createElement(Content_1.default, { message: props.referencedMessage, isReplyContent: true })) : (props.interaction && (react_1.default.createElement(Styles.SlashCommand, null,
            "used",
            " ",
            react_1.default.createElement(Styles.SlashCommandText, null,
                !props.isContextMenuInteraction ? "/" : "",
                props.interaction.name))))));
});
function NormalMessage(props) {
    var _a, _b, _c;
    const shouldShowReply = props.message.type === v10_1.MessageType.Reply ||
        Boolean(props.message.interaction);
    const { resolveChannel, resolveMember, currentUser } = (0, ConfigContext_1.useConfig)();
    const member = (0, react_1.useMemo)(() => {
        const channel = resolveChannel(props.message.channel_id);
        if (!channel || !("guild_id" in channel))
            return null;
        return resolveMember(props.message.author.id, channel.guild_id);
    }, [resolveChannel, resolveMember]);
    const isUserMentioned = (0, react_1.useMemo)(() => {
        var _a, _b;
        const userMentionedOverride = (_b = (_a = props.overrides) === null || _a === void 0 ? void 0 : _a.userMentioned) !== null && _b !== void 0 ? _b : false;
        if (userMentionedOverride)
            return true;
        const user = currentUser();
        if (!user)
            return false;
        return (props.message.mentions.find(({ id }) => id === user.id) !== undefined);
    }, [currentUser, props.message.mentions, (_a = props.overrides) === null || _a === void 0 ? void 0 : _a.userMentioned]);
    if (props.isFirstMessage)
        return (react_1.default.createElement(Styles.Message, { mentioned: isUserMentioned },
            shouldShowReply && (react_1.default.createElement(ReplyInfo, { channelId: props.message.channel_id, referencedMessage: props.message.referenced_message, mentioned: props.message.mentions.some((m) => { var _a; return m.id === ((_a = props.message.referenced_message) === null || _a === void 0 ? void 0 : _a.author.id); }), interaction: props.message.interaction, isContextMenuInteraction: props.isContextMenuInteraction })),
            react_1.default.createElement(Styles.MessageHeaderBase, null,
                react_1.default.createElement(MessageAuthor_1.default, { author: member !== null && member !== void 0 ? member : props.message.author, avatarAnimated: (_b = props.isHovered) !== null && _b !== void 0 ? _b : false, crossPost: Boolean(props.message.flags & (1 << 1)), referenceGuild: (_c = props.message.message_reference) === null || _c === void 0 ? void 0 : _c.guild_id }),
                props.hideTimestamp || (react_1.default.createElement(LargeTimestamp_1.default, { timestamp: props.message.timestamp }))),
            react_1.default.createElement(Content_1.default, { message: props.message, noThreadButton: props.noThreadButton })));
    return (react_1.default.createElement(Styles.Message, { mentioned: isUserMentioned },
        react_1.default.createElement(Tooltip_1.default, { placement: "top", overlay: (0, moment_1.default)(props.message.timestamp).format("LLLL"), mouseEnterDelay: 1 },
            react_1.default.createElement(Styles.SmallTimestamp, { dateTime: props.message.timestamp }, (0, moment_1.default)(props.message.timestamp).format("h:mm A"))),
        react_1.default.createElement(Content_1.default, { message: props.message, noThreadButton: props.noThreadButton })));
}
exports.default = NormalMessage;
//# sourceMappingURL=NormalMessage.js.map