"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const stitches_config_1 = require("./Stitches/stitches.config");
const Tooltip_1 = require("./Tooltip");
const hljs_1 = require("./markdown/render/elements/code/hljs");
const ConfigContext_1 = require("./core/ConfigContext");
const globalStyles = (0, stitches_config_1.globalCss)({
    [`.${Tooltip_1.tooltipPrefix}`]: {
        width: "fit-content",
        zIndex: 1070,
        display: "block",
        pointerEvents: "none",
        transformOrigin: "50% 50%",
        fontFamily: stitches_config_1.theme.fonts.main,
        transition: `scale ${Tooltip_1.tooltipAnimDurationMs}ms ease-out, opacity ${Tooltip_1.tooltipAnimDurationMs}ms ease-out`,
    },
    [`.${Tooltip_1.tooltipPrefix}-arrow`]: {
        marginBottom: -5,
        position: "absolute",
        width: 0,
        height: 0,
        borderColor: "transparent",
        borderStyle: "solid",
    },
    [`.${Tooltip_1.tooltipPrefix}-inner`]: {
        padding: "8px 12px",
        color: stitches_config_1.theme.colors.tooltipForeground,
        backgroundColor: stitches_config_1.theme.colors.tooltipBackground,
        textAlign: "left",
        textDecoration: "none",
        borderRadius: 5,
        fontSize: 14,
        fontWeight: 500,
        marginBottom: -5,
    },
    [`.${Tooltip_1.tooltipAnimPrefix}-enter, .${Tooltip_1.tooltipAnimPrefix}-appear`]: {
        scale: 0.9,
        opacity: 0,
    },
    [`.${Tooltip_1.tooltipAnimPrefix}-enter-active, .${Tooltip_1.tooltipAnimPrefix}-appear-active`]: {
        scale: 1,
        opacity: 1,
    },
    [`.${Tooltip_1.tooltipAnimPrefix}-leave`]: {
        scale: 1,
        opacity: 1,
    },
    [`.${Tooltip_1.tooltipAnimPrefix}-leave-active`]: {
        scale: 0.9,
        opacity: 0,
    },
    [`.${Tooltip_1.tooltipPrefix}-placement-top`]: {
        padding: "5px 0 9px 0",
        [`.${Tooltip_1.tooltipPrefix}-arrow`]: {
            bottom: 4,
            marginLeft: -5,
            borderWidth: "5px 5px 0",
            borderTopColor: stitches_config_1.theme.colors.tooltipBackground,
        },
    },
    [`.${Tooltip_1.tooltipPrefix}-placement-bottom`]: {
        padding: "9px 0 5px 0",
        [`.${Tooltip_1.tooltipPrefix}-arrow`]: {
            top: 4,
            marginLeft: -5,
            borderWidth: "0 5px 5px",
            borderBottomColor: stitches_config_1.theme.colors.tooltipBackground,
        },
    },
    [`.${Tooltip_1.tooltipPrefix}-placement-right`]: {
        padding: "0 5px 0 9px",
        [`.${Tooltip_1.tooltipPrefix}-arrow`]: {
            left: 4,
            marginTop: -5,
            borderWidth: "5px 5px 5px 0",
            borderRightColor: stitches_config_1.theme.colors.tooltipBackground,
        },
    },
    [`.${Tooltip_1.tooltipPrefix}-placement-left`]: {
        padding: "0 9px 0 5px",
        [`.${Tooltip_1.tooltipPrefix}-arrow`]: {
            right: 4,
            marginTop: -5,
            borderWidth: "5px 0 5px 5px",
            borderLeftColor: stitches_config_1.theme.colors.tooltipBackground,
        },
    },
    [`.${Tooltip_1.tooltipPrefix}-placement-top, .${Tooltip_1.tooltipPrefix}-placement-bottom`]: {
        [`.${Tooltip_1.tooltipPrefix}-arrow`]: {
            left: "50%",
        },
    },
    [`.${Tooltip_1.tooltipPrefix}-placement-right, .${Tooltip_1.tooltipPrefix}-placement-left`]: {
        [`.${Tooltip_1.tooltipPrefix}-arrow`]: {
            top: "50%",
        },
    },
});
const extraCss = (0, stitches_config_1.css)({
    fontFamily: stitches_config_1.theme.fonts.main,
    // backgroundColor: theme.colors.background, // todo: this is only for testing!
});
function MessageRendererProvider(_a) {
    var _b;
    var { children } = _a, config = __rest(_a, ["children"]);
    globalStyles();
    (0, hljs_1.hljsTheme)();
    return (react_1.default.createElement(ConfigContext_1.ConfigContext.Provider, { value: config }, children({ themeClass: `${stitches_config_1.theme} ${extraCss} ${(_b = config.themeOverrideClassName) !== null && _b !== void 0 ? _b : ''}` })));
}
exports.default = MessageRendererProvider;
//# sourceMappingURL=MessageRendererProvider.js.map