"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSvgUrl = void 0;
const react_1 = require("react");
const SvgMissingAsset = "data:image/svg+xml,%3Csvg width='64' height='64' viewBox='0 0 64 64' fill='none' xmlns='http://www.w3.org/2000/svg' id='svg'%3E%3Cg clip-path='url(%23clip0_604_44)'%3E%3Crect width='64' height='64' rx='6' fill='black'/%3E%3Cpath fill-rule='evenodd' clip-rule='evenodd' d='M0 0H32V32H0V0ZM64 32V64H32V32H64Z' fill='%23DC3ADF'/%3E%3C/g%3E%3Cdefs%3E%3CclipPath id='clip0_604_44'%3E%3Crect width='64' height='64' rx='6' fill='white'/%3E%3C/clipPath%3E%3C/defs%3E%3C/svg%3E%0A";
const ConfigContext_1 = require("./ConfigContext");
const defaultSvgUrls = {
    FileAudio: SvgMissingAsset,
    FileSketch: SvgMissingAsset,
    FileArchive: SvgMissingAsset,
    FileUnknown: SvgMissingAsset,
    FileAe: SvgMissingAsset,
    FileAi: SvgMissingAsset,
    FileAcrobat: SvgMissingAsset,
    FileCode: SvgMissingAsset,
    FileDocument: SvgMissingAsset,
    FileSpreadsheet: SvgMissingAsset,
    FileWebCode: SvgMissingAsset,
    IconAdd: SvgMissingAsset,
    IconRemove: SvgMissingAsset,
    IconDownload: SvgMissingAsset,
    IconWarning: SvgMissingAsset,
    IconCheckmark: SvgMissingAsset,
    IconCross: SvgMissingAsset,
    IconPin: SvgMissingAsset,
    IconPencil: SvgMissingAsset,
    IconBoost: SvgMissingAsset,
    IconThreadCreated: SvgMissingAsset,
    IconId: SvgMissingAsset,
    IconSticker: SvgMissingAsset,
    IconCommand: SvgMissingAsset,
    IconAttachment: SvgMissingAsset,
    IconDanger: SvgMissingAsset,
    IconPause: SvgMissingAsset,
    IconFullscreen: SvgMissingAsset,
    IconPlay: SvgMissingAsset,
    IconTextChannel: SvgMissingAsset,
    IconVoiceChannel: SvgMissingAsset,
    IconUnknownReply: SvgMissingAsset,
    IconStageChannel: SvgMissingAsset,
    IconForumChannel: SvgMissingAsset,
    MiscDiscordImageFailure: SvgMissingAsset,
    IconLinkExternal: SvgMissingAsset,
};
function getSvgUrl(svg) {
    var _a, _b;
    const { svgUrls } = (0, react_1.useContext)(ConfigContext_1.ConfigContext);
    return (_b = (_a = svgUrls === null || svgUrls === void 0 ? void 0 : svgUrls[svg]) !== null && _a !== void 0 ? _a : defaultSvgUrls[svg]) !== null && _b !== void 0 ? _b : svg;
}
exports.getSvgUrl = getSvgUrl;
//# sourceMappingURL=svgs.js.map