"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const text_1 = __importDefault(require("./text"));
const simple_markdown_1 = require("simple-markdown");
const customEmoji_1 = require("./customEmoji");
const Emoji_1 = __importDefault(require("../../../Emoji"));
const react_1 = __importStar(require("react"));
const mentions_1 = require("../elements/mentions");
const baseRules = {
    newline: simple_markdown_1.defaultRules.newline,
    paragraph: simple_markdown_1.defaultRules.paragraph,
    escape: simple_markdown_1.defaultRules.escape,
    link: simple_markdown_1.defaultRules.link,
    url: simple_markdown_1.defaultRules.url,
    strong: simple_markdown_1.defaultRules.strong,
    em: simple_markdown_1.defaultRules.em,
    u: simple_markdown_1.defaultRules.u,
    br: simple_markdown_1.defaultRules.br,
    inlineCode: simple_markdown_1.defaultRules.inlineCode,
    autolink: Object.assign(Object.assign({}, simple_markdown_1.defaultRules.autolink), { match: (0, simple_markdown_1.inlineRegex)(/^<(https?:\/\/[^ >]+)>/) }),
    blockQuote: Object.assign(Object.assign({}, simple_markdown_1.defaultRules.blockQuote), { match: (source, { prevCapture }) => /^$|\n *$/.test(prevCapture !== null && prevCapture !== void 0 ? prevCapture : "")
            ? /^( *>>> +([\s\S]*))|^( *>(?!>>) +[^\n]*(\n *>(?!>>) +[^\n]*)*\n?)/.exec(source)
            : null, parse: (capture, parse, state) => ({
            content: parse(capture[0].replace(/^ *>(?:>>)? ?/gm, ""), state),
        }) }),
    emoticon: {
        order: simple_markdown_1.defaultRules.text.order,
        match: (source) => /^(¯\\_\(ツ\)_\/¯)/.exec(source),
        parse: (capture) => ({ type: "text", content: capture[1] }),
    },
    codeBlock: {
        order: simple_markdown_1.defaultRules.codeBlock.order,
        match: (source) => /^```(([A-z0-9-]+?)\n+)?\n*([^]+?)\n*```/.exec(source),
        parse: ([, , lang, content]) => ({
            lang: (lang || "").trim(),
            content: content || "",
        }),
    },
    customEmoji: customEmoji_1.customEmoji,
    text: text_1.default,
    defaultEmoji: {
        order: simple_markdown_1.defaultRules.text.order,
        match: (source) => /^(?!<):([^\s:]+?):(?![0-9]+>)/gu.exec(source),
        parse: (match) => ({
            content: match[1],
        }),
        react: ({ content }, recurseOutput, state) => (react_1.default.createElement(react_1.Fragment, { key: state.key },
            react_1.default.createElement(Emoji_1.default, { emojiName: content }))),
    },
    // todo: mentions
    mention: mentions_1.userMention,
    channelMention: mentions_1.channelMention,
    roleMention: mentions_1.roleMention,
    s: {
        order: simple_markdown_1.defaultRules.u.order,
        match: (0, simple_markdown_1.inlineRegex)(/^~~([\s\S]+?)~~(?!_)/),
        parse: simple_markdown_1.defaultRules.u.parse,
    },
    spoiler: {
        order: simple_markdown_1.defaultRules.inlineCode.order + 1,
        match: (0, simple_markdown_1.inlineRegex)(/^\|\|([\s\S]+?)\|\|/),
        parse: simple_markdown_1.defaultRules.strong.parse,
    },
    timestamp: {
        order: simple_markdown_1.defaultRules.u.order,
        // https://github.com/discordjs/discord-api-types/blob/638c347dd8a1c5dc39b3626c76749c5f8a4afc6a/globals.ts#L69
        match: (0, simple_markdown_1.inlineRegex)(/^<t:(?<timestamp>-?\d{1,13})(:(?<style>[tTdDfFR]))?>/),
        parse: ({ groups }) => groups,
    },
    command: {
        order: simple_markdown_1.defaultRules.u.order,
        match: (0, simple_markdown_1.inlineRegex)(/^<\/(.+?):\d{17,19}?>/),
        parse: (capture) => ({ name: capture[1] }),
    },
};
exports.default = baseRules;
//# sourceMappingURL=index.js.map