"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InlineCode = exports.CodeBlock = void 0;
const stitches_config_1 = require("../../../../Stitches/stitches.config");
const fonts = `'${[
    "Consolas",
    "Operator Mono Lig",
    "Operator Mono Book",
    "Operator Mono",
    "Fira Code",
    "Menlo",
    "Monaco",
    "monospace",
].join(`','`)}'`;
exports.CodeBlock = stitches_config_1.styled.withConfig({
    displayName: "md-code-block",
    componentId: stitches_config_1.commonComponentId,
})("code", {
    display: "block",
    overflowX: "auto",
    borderRadius: 4,
    fontSize: stitches_config_1.theme.fontSizes.m,
    lineHeight: "1.125rem",
    textIndent: 0,
    whiteSpace: "pre-wrap",
    backgroundColor: stitches_config_1.theme.colors.backgroundSecondary,
    border: `1px solid ${stitches_config_1.theme.colors.backgroundTertiary}`,
    marginTop: stitches_config_1.theme.space.medium,
    padding: ".5em",
    fontFamily: fonts,
});
exports.InlineCode = stitches_config_1.styled.withConfig({
    displayName: "md-inline-code",
    componentId: stitches_config_1.commonComponentId,
})("code", {
    padding: ".2em",
    margin: "-.2em 0",
    textIndent: 0,
    fontSize: "85%",
    border: "none",
    whiteSpace: "pre-wrap",
    backgroundColor: stitches_config_1.theme.colors.backgroundSecondary,
    fontFamily: fonts,
});
//# sourceMappingURL=style.js.map