"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Highlighter = exports.Quote = exports.QuoteBar = exports.QuoteContainer = exports.Heading = exports.Link = void 0;
const stitches_config_1 = require("../../../Stitches/stitches.config");
exports.Link = stitches_config_1.styled.withConfig({
    displayName: "md-link",
    componentId: stitches_config_1.commonComponentId,
})("a", {
    "& code": {
        color: "inherit",
    },
});
exports.Heading = stitches_config_1.styled.withConfig({
    displayName: "heading",
    componentId: stitches_config_1.commonComponentId,
})("p", {
    margin: `${stitches_config_1.theme.space.xxl} 0 ${stitches_config_1.theme.space.large}`,
    fontWeight: 700,
    "&:first-child": {
        marginTop: stitches_config_1.theme.space.large,
    },
    variants: {
        kind: {
            1: {
                fontSize: stitches_config_1.theme.fontSizes.xxl,
            },
            2: {
                fontSize: stitches_config_1.theme.fontSizes.xl,
            },
            3: {
                fontSize: stitches_config_1.theme.fontSizes.l,
            },
        },
    },
});
exports.QuoteContainer = stitches_config_1.styled.withConfig({
    displayName: "md-quote-container",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    display: "flex",
});
exports.QuoteBar = stitches_config_1.styled.withConfig({
    displayName: "md-quote-bar",
    componentId: stitches_config_1.commonComponentId,
})("div", {
    margin: `${stitches_config_1.theme.space.large} 0`,
    width: 4,
    borderRadius: 4,
    backgroundColor: stitches_config_1.theme.colors.primaryOpacity10,
});
exports.Quote = stitches_config_1.styled.withConfig({
    displayName: "md-quote",
    componentId: stitches_config_1.commonComponentId,
})("blockquote", {
    padding: `0 ${stitches_config_1.theme.space.large} 0 ${stitches_config_1.theme.space.xl}`,
    boxSizing: "border-box",
    textIndent: 0,
    margin: `${stitches_config_1.theme.space.large} 0`,
    maxWidth: "90%",
});
var loader_1 = require("./code/loader");
Object.defineProperty(exports, "Highlighter", { enumerable: true, get: function () { return __importDefault(loader_1).default; } });
// export { Channel, Mention, Role } from "./mentions";
//# sourceMappingURL=index.js.map