"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.channelMention = void 0;
const Styles = __importStar(require("./style"));
const React = __importStar(require("react"));
const v10_1 = require("discord-api-types/v10");
const ConfigContext_1 = require("../../../../core/ConfigContext");
const simple_markdown_1 = __importDefault(require("simple-markdown"));
const SvgFromUrl_1 = __importDefault(require("../../../../SvgFromUrl"));
function getChannelTypeSvg(type) {
    switch (type) {
        case v10_1.ChannelType.GuildVoice:
            return "IconVoiceChannel";
        case v10_1.ChannelType.GuildStageVoice:
            return "IconStageChannel";
        default:
            return "IconTextChannel";
    }
}
function ChannelMention({ channelId }) {
    const { resolveChannel, channelMentionOnClick } = (0, ConfigContext_1.useConfig)();
    const channel = resolveChannel(channelId);
    if (!channel) {
        return (React.createElement(Styles.Mention, null,
            React.createElement(Styles.MentionIcon, { as: SvgFromUrl_1.default, width: 16, height: 16, svg: "IconTextChannel" }),
            "Unknown"));
    }
    const icon = getChannelTypeSvg(channel.type);
    return (React.createElement(Styles.Mention, { onClick: () => channelMentionOnClick === null || channelMentionOnClick === void 0 ? void 0 : channelMentionOnClick(channel), canBeClicked: channelMentionOnClick !== undefined },
        React.createElement(Styles.MentionIcon, { as: SvgFromUrl_1.default, width: 16, height: 16, svg: icon }),
        channel.name));
}
exports.channelMention = {
    order: simple_markdown_1.default.defaultRules.text.order,
    match: (source) => /^<#([0-9]+?)>/.exec(source),
    parse: ([, id]) => ({ id }),
    react: ({ id }, recurseParse, state) => (React.createElement(ChannelMention, { channelId: id, key: state.key })),
};
//# sourceMappingURL=channelMention.js.map