"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.roleMention = void 0;
const Styles = __importStar(require("./style"));
const React = __importStar(require("react"));
const ConfigContext_1 = require("../../../../core/ConfigContext");
const simple_markdown_1 = __importDefault(require("simple-markdown"));
function RoleMention({ roleId }) {
    const { resolveRole, roleMentionOnClick } = (0, ConfigContext_1.useConfig)();
    const role = resolveRole(roleId);
    if (!role) {
        return React.createElement(React.Fragment, null, "@deleted-role");
    }
    const red = (role.color & 16711680) >> 16;
    const green = (role.color & 65280) >> 8;
    const blue = role.color & 255;
    return (React.createElement(Styles.Mention, { style: {
            color: `rgb(${red}, ${green}, ${blue})`,
            backgroundColor: `rgba(${red}, ${green}, ${blue}, 0.1)`,
        }, onClick: () => roleMentionOnClick === null || roleMentionOnClick === void 0 ? void 0 : roleMentionOnClick(role), canBeClicked: roleMentionOnClick !== undefined },
        React.createElement(Styles.MentionIcon, null, "@"),
        role.name));
}
exports.roleMention = {
    order: simple_markdown_1.default.defaultRules.text.order,
    match: (source) => /^<@&([0-9]+?)>/.exec(source),
    parse: ([, id]) => ({ id }),
    react: ({ id }, recurseParse, state) => (React.createElement(RoleMention, { roleId: id, key: state.key })),
};
//# sourceMappingURL=roleMention.js.map