"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.userMention = void 0;
const Styles = __importStar(require("./style"));
const React = __importStar(require("react"));
const ConfigContext_1 = require("../../../../core/ConfigContext");
const simple_markdown_1 = __importDefault(require("simple-markdown"));
const getDisplayName_1 = __importDefault(require("../../../../utils/getDisplayName"));
function UserMention({ userId }) {
    const { resolveUser, userMentionOnClick } = (0, ConfigContext_1.useConfig)();
    // todo: resolve current channel to resolve member
    const user = resolveUser(userId);
    const text = user ? (0, getDisplayName_1.default)(user) : "Unknown User";
    return (React.createElement(Styles.Mention, { onClick: () => userMentionOnClick === null || userMentionOnClick === void 0 ? void 0 : userMentionOnClick(user), canBeClicked: userMentionOnClick !== undefined },
        React.createElement(Styles.MentionIcon, null, "@"),
        text));
}
exports.userMention = {
    order: simple_markdown_1.default.defaultRules.text.order,
    match: (source) => /^<@!?([0-9]+?)>/.exec(source),
    parse: ([, id]) => ({ id }),
    react: ({ id }, recurseParse, state) => (React.createElement(UserMention, { userId: id, key: state.key })),
};
//# sourceMappingURL=userMention.js.map