"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LinkMarkdown = exports.parseEmbedTitle = exports.parseAllowLinks = void 0;
const memoizee_1 = __importDefault(require("memoizee"));
const R = __importStar(require("ramda"));
const ast_1 = __importDefault(require("./ast"));
const elements_1 = require("./elements");
const Styles = __importStar(require("./elements"));
const util_1 = require("./util");
const simple_markdown_1 = __importStar(require("simple-markdown"));
const TextSpoiler_1 = __importDefault(require("./elements/TextSpoiler"));
const Timestamp_1 = require("./elements/Timestamp");
const react_1 = __importDefault(require("react"));
const style_1 = require("./elements/code/style");
const emojiData_1 = require("../../emojiData");
function parserFor(rules, returnAst) {
    const parser = simple_markdown_1.default.parserFor(rules);
    const renderer = simple_markdown_1.default.outputFor(rules, "react");
    return (0, memoizee_1.default)((input = "", inline = true, state = {}, transform = null) => {
        if (!inline) {
            input += "\n\n";
        }
        const parse = R.pipe.apply(this, [parser, util_1.flattenAst, transform, !returnAst && renderer].filter(Boolean));
        return parse(input, Object.assign({ inline }, state));
    }, {
        normalizer: (...args) => JSON.stringify(args),
    });
}
function createRules(rule) {
    const { paragraph, url, link, codeBlock, inlineCode, blockQuote, spoiler, timestamp, command, } = rule;
    return Object.assign(Object.assign({}, rule), { heading: Object.assign(Object.assign({}, simple_markdown_1.defaultRules.heading), { match: (source, state) => {
                const prevCaptureStr = state.prevCapture === null ? "" : state.prevCapture[0];
                const isStartOfLineCapture = /(?:^|\n)( *)$/.exec(prevCaptureStr);
                if (isStartOfLineCapture) {
                    source = isStartOfLineCapture[1] + source;
                    return /^ *(#{1,3})([^\n]+?)(?:\n|$)/.exec(source);
                }
                return null;
            }, react(node, parse, state) {
                return (react_1.default.createElement(Styles.Heading, { key: state.key, kind: node.level }, parse(node.content, state)));
            } }), s: {
            order: rule.u.order,
            match: simple_markdown_1.default.inlineRegex(/^~~([\s\S]+?)~~(?!_)/),
            parse: rule.u.parse,
            react: (node, recurseOutput, state) => (react_1.default.createElement("s", { key: state.key }, recurseOutput(node.content, state))),
        }, paragraph: Object.assign(Object.assign({}, paragraph), { react: (node, recurseOutput, state) => (react_1.default.createElement("p", { key: state.key }, recurseOutput(node.content, state))) }), url: Object.assign(Object.assign({}, url), { match: simple_markdown_1.default.inlineRegex(/^((https?|steam):\/\/[^\s<]+[^<.,:;"')\]\s])/) }), link: Object.assign(Object.assign({}, link), { react: (node, recurseOutput, state) => (react_1.default.createElement(Styles.Link, { title: node.title || (0, util_1.astToString)(node.content), href: simple_markdown_1.default.sanitizeUrl(node.target), target: "_blank", rel: "noreferrer", key: state.key }, recurseOutput(node.content, state))) }), inlineCode: Object.assign(Object.assign({}, inlineCode), { react: (node, recurseOutput, state) => (react_1.default.createElement(style_1.InlineCode, { key: state.key }, (0, util_1.recurse)(node, recurseOutput, state))) }), codeBlock: Object.assign(Object.assign({}, codeBlock), { react: (node, recurseOutput, state) => (react_1.default.createElement(elements_1.Highlighter, { key: state.key, language: node.lang }, (0, util_1.recurse)(node, recurseOutput, state))) }), blockQuote: Object.assign(Object.assign({}, blockQuote), { react: (node, recurseOutput, state) => (react_1.default.createElement(Styles.QuoteContainer, { key: state.key },
                react_1.default.createElement(Styles.QuoteBar, null),
                react_1.default.createElement(Styles.Quote, null, (0, util_1.recurse)(node, recurseOutput, state)))) }), spoiler: Object.assign(Object.assign({}, spoiler), { react: (node, recurseOutput, state) => (react_1.default.createElement(TextSpoiler_1.default, { content: (0, util_1.recurse)(node, recurseOutput, state), key: state.key })) }), timestamp: Object.assign(Object.assign({}, timestamp), { react: (data, recurseOutput, state) => (react_1.default.createElement(Timestamp_1.Timestamp, { data: data, key: state.key })) }), command: Object.assign(Object.assign({}, command), { react: ({ name }) => "/" + name }) });
}
const rulesWithoutMaskedLinks = createRules(Object.assign(Object.assign({}, ast_1.default), { link: Object.assign(Object.assign({}, ast_1.default.link), { match: () => null }) }));
const parse = parserFor(rulesWithoutMaskedLinks);
exports.parseAllowLinks = parserFor(createRules(ast_1.default));
exports.parseEmbedTitle = parserFor(R.omit(["codeBlock", "br", "mention", "channelMention", "roleMention"], rulesWithoutMaskedLinks));
function handleUnicodeEmojis(content) {
    return content.replace(/(\p{RI}\p{RI}|\p{Emoji}(?:\p{EMod}|\u{FE0F}\u{20E3}?|[\u{E0020}-\u{E007E}]+\u{E007F})?(?:\u{200D}(?:\p{RI}\p{RI}|\p{Emoji}(\p{EMod}|\u{FE0F}\u{20E3}?|[\u{E0020}-\u{E007E}]+\u{E007F})?))*)/gu, (match) => {
        const emojiResult = (0, emojiData_1.findDefaultEmojiByUnicode)(match);
        if (!emojiResult)
            return match;
        return `:${emojiResult.emoji}:`;
    });
}
function Markdown({ children: content, mentions, users, }) {
    const unicodeEmojisHandled = handleUnicodeEmojis(content);
    return content
        ? parse(unicodeEmojisHandled, undefined, { mentions, users })
        : null;
}
function LinkMarkdown({ children: content, mentions, users, }) {
    const unicodeEmojisHandled = handleUnicodeEmojis(content);
    return content
        ? (0, exports.parseAllowLinks)(unicodeEmojisHandled, undefined, { mentions, users })
        : null;
}
exports.LinkMarkdown = LinkMarkdown;
exports.default = Markdown;
//# sourceMappingURL=index.js.map