"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function gifCheck(url) {
    return (url === null || url === void 0 ? void 0 : url.includes("/a_")) ? url.replace("webp", "gif") : url;
}
function getAvatarProperty(user, avatarSize = 80) {
    if (!user.avatar)
        return null;
    // todo: allow custom CDN
    return `https://cdn.discordapp.com/avatars/${user.id}/${user.avatar}.webp?size=${avatarSize}`;
}
function getAvatar(user, { animated, size } = {}) {
    var _a;
    // assign default values
    animated !== null && animated !== void 0 ? animated : (animated = false);
    size !== null && size !== void 0 ? size : (size = 80);
    const avatarUrl = getAvatarProperty(user, size);
    const potentialGif = animated ? gifCheck(avatarUrl) : avatarUrl;
    return avatarUrl
        ? potentialGif.replace("webp", "png")
        : `https://cdn.discordapp.com/embed/avatars/${Number((_a = user.discriminator) !== null && _a !== void 0 ? _a : 0) % 5}.png`;
}
exports.default = getAvatar;
//# sourceMappingURL=getAvatar.js.map