/// <reference types="react" />
import type { APIChannel, APIGuild, APIGuildMember, APIMessage, APIRole, APIUser, Snowflake } from "discord-api-types/v10";
import type { SvgConfig } from "./svgs";
export type PartialSvgConfig = Partial<SvgConfig>;
export interface MessageButtonListOption<SC extends PartialSvgConfig> {
    onClick: () => void;
    icon: keyof SC;
    actionDescription: string;
}
export type Config<SvgConfig extends PartialSvgConfig> = {
    svgUrls?: SvgConfig;
    messageButtons(message: APIMessage): MessageButtonListOption<SvgConfig>[];
    resolveRole(id: Snowflake): APIRole | null;
    resolveChannel(id: Snowflake): APIChannel | null;
    resolveMember(id: Snowflake, guildId: Snowflake): APIGuildMember | null;
    resolveGuild(id: Snowflake): APIGuild | null;
    resolveUser(id: Snowflake): APIUser | null;
    currentUser(): APIUser | null;
    seeThreadOnClick?(messageId: Snowflake, thread: APIChannel): void;
    userMentionOnClick?(user: APIUser): void;
    roleMentionOnClick?(role: APIRole): void;
    channelMentionOnClick?(channel: APIChannel): void;
    messageComponentButtonOnClick?(message: APIMessage, customId: string): void;
    themeOverrideClassName?: string;
};
export declare const ConfigContext: import("react").Context<Config<Partial<SvgConfig>>>;
export declare function useConfig(): Config<Partial<SvgConfig>>;
